import { getStructEncoder, getStructDecoder, combineCodec, addEncoderSizePrefix, getUtf8Encoder, getU32Encoder, addDecoderSizePrefix, getUtf8Decoder, getU32Decoder, getArrayEncoder, getArrayDecoder, getDiscriminatedUnionEncoder, getUnitEncoder, getAddressEncoder, getDiscriminatedUnionDecoder, getUnitDecoder, getAddressDecoder, getU64Encoder, getU64Decoder, getU8Encoder, getU8Decoder, getEnumEncoder, getEnumDecoder, getOptionEncoder, getOptionDecoder, getTupleEncoder, getTupleDecoder, getBooleanEncoder, getBooleanDecoder, fixEncoderSize, getBytesEncoder, fixDecoderSize, getBytesDecoder, getU16Encoder, getU16Decoder, decodeAccount, assertAccountExists, fetchEncodedAccount, assertAccountsExist, fetchEncodedAccounts, containsBytes, isProgramError, transformEncoder, generateKeyPairSigner, pipe, appendTransactionMessageInstruction, AccountRole, upgradeRoleToSigner, isTransactionSigner as isTransactionSigner$1 } from '@solana/web3.js';
import { createDefaultTransaction, signAndSendTransaction } from '@tensor-foundation/test-helpers';

// src/generated/accounts/assetV1.ts
function getAddBlockerEncoder() {
  return getStructEncoder([]);
}
function getAddBlockerDecoder() {
  return getStructDecoder([]);
}
function getAddBlockerCodec() {
  return combineCodec(getAddBlockerEncoder(), getAddBlockerDecoder());
}
function getAttributeEncoder() {
  return getStructEncoder([
    ["key", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["value", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())]
  ]);
}
function getAttributeDecoder() {
  return getStructDecoder([
    ["key", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["value", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())]
  ]);
}
function getAttributeCodec() {
  return combineCodec(getAttributeEncoder(), getAttributeDecoder());
}
function getAttributesEncoder() {
  return getStructEncoder([
    ["attributeList", getArrayEncoder(getAttributeEncoder())]
  ]);
}
function getAttributesDecoder() {
  return getStructDecoder([
    ["attributeList", getArrayDecoder(getAttributeDecoder())]
  ]);
}
function getAttributesCodec() {
  return combineCodec(getAttributesEncoder(), getAttributesDecoder());
}
function getAuthorityEncoder() {
  return getDiscriminatedUnionEncoder([
    ["None", getUnitEncoder()],
    ["Owner", getUnitEncoder()],
    ["UpdateAuthority", getUnitEncoder()],
    ["Address", getStructEncoder([["address", getAddressEncoder()]])]
  ]);
}
function getAuthorityDecoder() {
  return getDiscriminatedUnionDecoder([
    ["None", getUnitDecoder()],
    ["Owner", getUnitDecoder()],
    ["UpdateAuthority", getUnitDecoder()],
    ["Address", getStructDecoder([["address", getAddressDecoder()]])]
  ]);
}
function getAuthorityCodec() {
  return combineCodec(getAuthorityEncoder(), getAuthorityDecoder());
}
function authority(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isAuthority(kind, value) {
  return value.__kind === kind;
}
function getAutographEncoder() {
  return getStructEncoder([
    ["signatures", getArrayEncoder(getAutographSignatureEncoder())]
  ]);
}
function getAutographDecoder() {
  return getStructDecoder([
    ["signatures", getArrayDecoder(getAutographSignatureDecoder())]
  ]);
}
function getAutographCodec() {
  return combineCodec(getAutographEncoder(), getAutographDecoder());
}
function getAutographSignatureEncoder() {
  return getStructEncoder([
    ["address", getAddressEncoder()],
    ["message", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())]
  ]);
}
function getAutographSignatureDecoder() {
  return getStructDecoder([
    ["address", getAddressDecoder()],
    ["message", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())]
  ]);
}
function getAutographSignatureCodec() {
  return combineCodec(
    getAutographSignatureEncoder(),
    getAutographSignatureDecoder()
  );
}
function getBurnDelegateEncoder() {
  return getStructEncoder([]);
}
function getBurnDelegateDecoder() {
  return getStructDecoder([]);
}
function getBurnDelegateCodec() {
  return combineCodec(getBurnDelegateEncoder(), getBurnDelegateDecoder());
}
function getCompressionProofEncoder() {
  return getStructEncoder([
    ["owner", getAddressEncoder()],
    ["updateAuthority", getUpdateAuthorityEncoder()],
    ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["seq", getU64Encoder()],
    ["plugins", getArrayEncoder(getHashablePluginSchemaEncoder())]
  ]);
}
function getCompressionProofDecoder() {
  return getStructDecoder([
    ["owner", getAddressDecoder()],
    ["updateAuthority", getUpdateAuthorityDecoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["seq", getU64Decoder()],
    ["plugins", getArrayDecoder(getHashablePluginSchemaDecoder())]
  ]);
}
function getCompressionProofCodec() {
  return combineCodec(
    getCompressionProofEncoder(),
    getCompressionProofDecoder()
  );
}
function getCreatorEncoder() {
  return getStructEncoder([
    ["address", getAddressEncoder()],
    ["percentage", getU8Encoder()]
  ]);
}
function getCreatorDecoder() {
  return getStructDecoder([
    ["address", getAddressDecoder()],
    ["percentage", getU8Decoder()]
  ]);
}
function getCreatorCodec() {
  return combineCodec(getCreatorEncoder(), getCreatorDecoder());
}
var DataState = /* @__PURE__ */ ((DataState2) => {
  DataState2[DataState2["AccountState"] = 0] = "AccountState";
  DataState2[DataState2["LedgerState"] = 1] = "LedgerState";
  return DataState2;
})(DataState || {});
function getDataStateEncoder() {
  return getEnumEncoder(DataState);
}
function getDataStateDecoder() {
  return getEnumDecoder(DataState);
}
function getDataStateCodec() {
  return combineCodec(getDataStateEncoder(), getDataStateDecoder());
}
function getDataStoreEncoder() {
  return getStructEncoder([
    ["dataAuthority", getAuthorityEncoder()],
    ["schema", getExternalPluginAdapterSchemaEncoder()]
  ]);
}
function getDataStoreDecoder() {
  return getStructDecoder([
    ["dataAuthority", getAuthorityDecoder()],
    ["schema", getExternalPluginAdapterSchemaDecoder()]
  ]);
}
function getDataStoreCodec() {
  return combineCodec(getDataStoreEncoder(), getDataStoreDecoder());
}
function getDataStoreInitInfoEncoder() {
  return getStructEncoder([
    ["dataAuthority", getAuthorityEncoder()],
    ["initPluginAuthority", getOptionEncoder(getAuthorityEncoder())],
    ["schema", getOptionEncoder(getExternalPluginAdapterSchemaEncoder())]
  ]);
}
function getDataStoreInitInfoDecoder() {
  return getStructDecoder([
    ["dataAuthority", getAuthorityDecoder()],
    ["initPluginAuthority", getOptionDecoder(getAuthorityDecoder())],
    ["schema", getOptionDecoder(getExternalPluginAdapterSchemaDecoder())]
  ]);
}
function getDataStoreInitInfoCodec() {
  return combineCodec(
    getDataStoreInitInfoEncoder(),
    getDataStoreInitInfoDecoder()
  );
}
function getDataStoreUpdateInfoEncoder() {
  return getStructEncoder([
    ["schema", getOptionEncoder(getExternalPluginAdapterSchemaEncoder())]
  ]);
}
function getDataStoreUpdateInfoDecoder() {
  return getStructDecoder([
    ["schema", getOptionDecoder(getExternalPluginAdapterSchemaDecoder())]
  ]);
}
function getDataStoreUpdateInfoCodec() {
  return combineCodec(
    getDataStoreUpdateInfoEncoder(),
    getDataStoreUpdateInfoDecoder()
  );
}
function getEditionEncoder() {
  return getStructEncoder([["number", getU32Encoder()]]);
}
function getEditionDecoder() {
  return getStructDecoder([["number", getU32Decoder()]]);
}
function getEditionCodec() {
  return combineCodec(getEditionEncoder(), getEditionDecoder());
}
function getExternalCheckResultEncoder() {
  return getStructEncoder([["flags", getU32Encoder()]]);
}
function getExternalCheckResultDecoder() {
  return getStructDecoder([["flags", getU32Decoder()]]);
}
function getExternalCheckResultCodec() {
  return combineCodec(
    getExternalCheckResultEncoder(),
    getExternalCheckResultDecoder()
  );
}
function getExternalPluginAdapterEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "LifecycleHook",
      getStructEncoder([
        ["fields", getTupleEncoder([getLifecycleHookEncoder()])]
      ])
    ],
    [
      "Oracle",
      getStructEncoder([["fields", getTupleEncoder([getOracleEncoder()])]])
    ],
    [
      "DataStore",
      getStructEncoder([["fields", getTupleEncoder([getDataStoreEncoder()])]])
    ]
  ]);
}
function getExternalPluginAdapterDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "LifecycleHook",
      getStructDecoder([
        ["fields", getTupleDecoder([getLifecycleHookDecoder()])]
      ])
    ],
    [
      "Oracle",
      getStructDecoder([["fields", getTupleDecoder([getOracleDecoder()])]])
    ],
    [
      "DataStore",
      getStructDecoder([["fields", getTupleDecoder([getDataStoreDecoder()])]])
    ]
  ]);
}
function getExternalPluginAdapterCodec() {
  return combineCodec(
    getExternalPluginAdapterEncoder(),
    getExternalPluginAdapterDecoder()
  );
}
function externalPluginAdapter(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isExternalPluginAdapter(kind, value) {
  return value.__kind === kind;
}
function getExternalPluginAdapterInitInfoEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "LifecycleHook",
      getStructEncoder([
        ["fields", getTupleEncoder([getLifecycleHookInitInfoEncoder()])]
      ])
    ],
    [
      "Oracle",
      getStructEncoder([
        ["fields", getTupleEncoder([getOracleInitInfoEncoder()])]
      ])
    ],
    [
      "DataStore",
      getStructEncoder([
        ["fields", getTupleEncoder([getDataStoreInitInfoEncoder()])]
      ])
    ]
  ]);
}
function getExternalPluginAdapterInitInfoDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "LifecycleHook",
      getStructDecoder([
        ["fields", getTupleDecoder([getLifecycleHookInitInfoDecoder()])]
      ])
    ],
    [
      "Oracle",
      getStructDecoder([
        ["fields", getTupleDecoder([getOracleInitInfoDecoder()])]
      ])
    ],
    [
      "DataStore",
      getStructDecoder([
        ["fields", getTupleDecoder([getDataStoreInitInfoDecoder()])]
      ])
    ]
  ]);
}
function getExternalPluginAdapterInitInfoCodec() {
  return combineCodec(
    getExternalPluginAdapterInitInfoEncoder(),
    getExternalPluginAdapterInitInfoDecoder()
  );
}
function externalPluginAdapterInitInfo(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isExternalPluginAdapterInitInfo(kind, value) {
  return value.__kind === kind;
}
function getExternalPluginAdapterKeyEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "LifecycleHook",
      getStructEncoder([["fields", getTupleEncoder([getAddressEncoder()])]])
    ],
    [
      "Oracle",
      getStructEncoder([["fields", getTupleEncoder([getAddressEncoder()])]])
    ],
    [
      "DataStore",
      getStructEncoder([["fields", getTupleEncoder([getAuthorityEncoder()])]])
    ]
  ]);
}
function getExternalPluginAdapterKeyDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "LifecycleHook",
      getStructDecoder([["fields", getTupleDecoder([getAddressDecoder()])]])
    ],
    [
      "Oracle",
      getStructDecoder([["fields", getTupleDecoder([getAddressDecoder()])]])
    ],
    [
      "DataStore",
      getStructDecoder([["fields", getTupleDecoder([getAuthorityDecoder()])]])
    ]
  ]);
}
function getExternalPluginAdapterKeyCodec() {
  return combineCodec(
    getExternalPluginAdapterKeyEncoder(),
    getExternalPluginAdapterKeyDecoder()
  );
}
function externalPluginAdapterKey(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isExternalPluginAdapterKey(kind, value) {
  return value.__kind === kind;
}
var ExternalPluginAdapterSchema = /* @__PURE__ */ ((ExternalPluginAdapterSchema2) => {
  ExternalPluginAdapterSchema2[ExternalPluginAdapterSchema2["Binary"] = 0] = "Binary";
  ExternalPluginAdapterSchema2[ExternalPluginAdapterSchema2["Json"] = 1] = "Json";
  ExternalPluginAdapterSchema2[ExternalPluginAdapterSchema2["MsgPack"] = 2] = "MsgPack";
  return ExternalPluginAdapterSchema2;
})(ExternalPluginAdapterSchema || {});
function getExternalPluginAdapterSchemaEncoder() {
  return getEnumEncoder(ExternalPluginAdapterSchema);
}
function getExternalPluginAdapterSchemaDecoder() {
  return getEnumDecoder(ExternalPluginAdapterSchema);
}
function getExternalPluginAdapterSchemaCodec() {
  return combineCodec(
    getExternalPluginAdapterSchemaEncoder(),
    getExternalPluginAdapterSchemaDecoder()
  );
}
var ExternalPluginAdapterType = /* @__PURE__ */ ((ExternalPluginAdapterType2) => {
  ExternalPluginAdapterType2[ExternalPluginAdapterType2["LifecycleHook"] = 0] = "LifecycleHook";
  ExternalPluginAdapterType2[ExternalPluginAdapterType2["Oracle"] = 1] = "Oracle";
  ExternalPluginAdapterType2[ExternalPluginAdapterType2["DataStore"] = 2] = "DataStore";
  return ExternalPluginAdapterType2;
})(ExternalPluginAdapterType || {});
function getExternalPluginAdapterTypeEncoder() {
  return getEnumEncoder(ExternalPluginAdapterType);
}
function getExternalPluginAdapterTypeDecoder() {
  return getEnumDecoder(ExternalPluginAdapterType);
}
function getExternalPluginAdapterTypeCodec() {
  return combineCodec(
    getExternalPluginAdapterTypeEncoder(),
    getExternalPluginAdapterTypeDecoder()
  );
}
function getExternalPluginAdapterUpdateInfoEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "LifecycleHook",
      getStructEncoder([
        ["fields", getTupleEncoder([getLifecycleHookUpdateInfoEncoder()])]
      ])
    ],
    [
      "Oracle",
      getStructEncoder([
        ["fields", getTupleEncoder([getOracleUpdateInfoEncoder()])]
      ])
    ],
    [
      "DataStore",
      getStructEncoder([
        ["fields", getTupleEncoder([getDataStoreUpdateInfoEncoder()])]
      ])
    ]
  ]);
}
function getExternalPluginAdapterUpdateInfoDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "LifecycleHook",
      getStructDecoder([
        ["fields", getTupleDecoder([getLifecycleHookUpdateInfoDecoder()])]
      ])
    ],
    [
      "Oracle",
      getStructDecoder([
        ["fields", getTupleDecoder([getOracleUpdateInfoDecoder()])]
      ])
    ],
    [
      "DataStore",
      getStructDecoder([
        ["fields", getTupleDecoder([getDataStoreUpdateInfoDecoder()])]
      ])
    ]
  ]);
}
function getExternalPluginAdapterUpdateInfoCodec() {
  return combineCodec(
    getExternalPluginAdapterUpdateInfoEncoder(),
    getExternalPluginAdapterUpdateInfoDecoder()
  );
}
function externalPluginAdapterUpdateInfo(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isExternalPluginAdapterUpdateInfo(kind, value) {
  return value.__kind === kind;
}
function getExternalRegistryRecordEncoder() {
  return getStructEncoder([
    ["pluginType", getExternalPluginAdapterTypeEncoder()],
    ["authority", getAuthorityEncoder()],
    [
      "lifecycleChecks",
      getOptionEncoder(
        getArrayEncoder(
          getTupleEncoder([
            getHookableLifecycleEventEncoder(),
            getExternalCheckResultEncoder()
          ])
        )
      )
    ],
    ["offset", getU64Encoder()],
    ["dataOffset", getOptionEncoder(getU64Encoder())],
    ["dataLen", getOptionEncoder(getU64Encoder())]
  ]);
}
function getExternalRegistryRecordDecoder() {
  return getStructDecoder([
    ["pluginType", getExternalPluginAdapterTypeDecoder()],
    ["authority", getAuthorityDecoder()],
    [
      "lifecycleChecks",
      getOptionDecoder(
        getArrayDecoder(
          getTupleDecoder([
            getHookableLifecycleEventDecoder(),
            getExternalCheckResultDecoder()
          ])
        )
      )
    ],
    ["offset", getU64Decoder()],
    ["dataOffset", getOptionDecoder(getU64Decoder())],
    ["dataLen", getOptionDecoder(getU64Decoder())]
  ]);
}
function getExternalRegistryRecordCodec() {
  return combineCodec(
    getExternalRegistryRecordEncoder(),
    getExternalRegistryRecordDecoder()
  );
}
var ExternalValidationResult = /* @__PURE__ */ ((ExternalValidationResult2) => {
  ExternalValidationResult2[ExternalValidationResult2["Approved"] = 0] = "Approved";
  ExternalValidationResult2[ExternalValidationResult2["Rejected"] = 1] = "Rejected";
  ExternalValidationResult2[ExternalValidationResult2["Pass"] = 2] = "Pass";
  return ExternalValidationResult2;
})(ExternalValidationResult || {});
function getExternalValidationResultEncoder() {
  return getEnumEncoder(ExternalValidationResult);
}
function getExternalValidationResultDecoder() {
  return getEnumDecoder(ExternalValidationResult);
}
function getExternalValidationResultCodec() {
  return combineCodec(
    getExternalValidationResultEncoder(),
    getExternalValidationResultDecoder()
  );
}
function getExtraAccountEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "PreconfiguredProgram",
      getStructEncoder([
        ["isSigner", getBooleanEncoder()],
        ["isWritable", getBooleanEncoder()]
      ])
    ],
    [
      "PreconfiguredCollection",
      getStructEncoder([
        ["isSigner", getBooleanEncoder()],
        ["isWritable", getBooleanEncoder()]
      ])
    ],
    [
      "PreconfiguredOwner",
      getStructEncoder([
        ["isSigner", getBooleanEncoder()],
        ["isWritable", getBooleanEncoder()]
      ])
    ],
    [
      "PreconfiguredRecipient",
      getStructEncoder([
        ["isSigner", getBooleanEncoder()],
        ["isWritable", getBooleanEncoder()]
      ])
    ],
    [
      "PreconfiguredAsset",
      getStructEncoder([
        ["isSigner", getBooleanEncoder()],
        ["isWritable", getBooleanEncoder()]
      ])
    ],
    [
      "CustomPda",
      getStructEncoder([
        ["seeds", getArrayEncoder(getSeedEncoder())],
        ["customProgramId", getOptionEncoder(getAddressEncoder())],
        ["isSigner", getBooleanEncoder()],
        ["isWritable", getBooleanEncoder()]
      ])
    ],
    [
      "Address",
      getStructEncoder([
        ["address", getAddressEncoder()],
        ["isSigner", getBooleanEncoder()],
        ["isWritable", getBooleanEncoder()]
      ])
    ]
  ]);
}
function getExtraAccountDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "PreconfiguredProgram",
      getStructDecoder([
        ["isSigner", getBooleanDecoder()],
        ["isWritable", getBooleanDecoder()]
      ])
    ],
    [
      "PreconfiguredCollection",
      getStructDecoder([
        ["isSigner", getBooleanDecoder()],
        ["isWritable", getBooleanDecoder()]
      ])
    ],
    [
      "PreconfiguredOwner",
      getStructDecoder([
        ["isSigner", getBooleanDecoder()],
        ["isWritable", getBooleanDecoder()]
      ])
    ],
    [
      "PreconfiguredRecipient",
      getStructDecoder([
        ["isSigner", getBooleanDecoder()],
        ["isWritable", getBooleanDecoder()]
      ])
    ],
    [
      "PreconfiguredAsset",
      getStructDecoder([
        ["isSigner", getBooleanDecoder()],
        ["isWritable", getBooleanDecoder()]
      ])
    ],
    [
      "CustomPda",
      getStructDecoder([
        ["seeds", getArrayDecoder(getSeedDecoder())],
        ["customProgramId", getOptionDecoder(getAddressDecoder())],
        ["isSigner", getBooleanDecoder()],
        ["isWritable", getBooleanDecoder()]
      ])
    ],
    [
      "Address",
      getStructDecoder([
        ["address", getAddressDecoder()],
        ["isSigner", getBooleanDecoder()],
        ["isWritable", getBooleanDecoder()]
      ])
    ]
  ]);
}
function getExtraAccountCodec() {
  return combineCodec(getExtraAccountEncoder(), getExtraAccountDecoder());
}
function extraAccount(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isExtraAccount(kind, value) {
  return value.__kind === kind;
}
function getFreezeDelegateEncoder() {
  return getStructEncoder([["frozen", getBooleanEncoder()]]);
}
function getFreezeDelegateDecoder() {
  return getStructDecoder([["frozen", getBooleanDecoder()]]);
}
function getFreezeDelegateCodec() {
  return combineCodec(getFreezeDelegateEncoder(), getFreezeDelegateDecoder());
}
function getHashablePluginSchemaEncoder() {
  return getStructEncoder([
    ["index", getU64Encoder()],
    ["authority", getAuthorityEncoder()],
    ["plugin", getPluginEncoder()]
  ]);
}
function getHashablePluginSchemaDecoder() {
  return getStructDecoder([
    ["index", getU64Decoder()],
    ["authority", getAuthorityDecoder()],
    ["plugin", getPluginDecoder()]
  ]);
}
function getHashablePluginSchemaCodec() {
  return combineCodec(
    getHashablePluginSchemaEncoder(),
    getHashablePluginSchemaDecoder()
  );
}
function getHashedAssetSchemaEncoder() {
  return getStructEncoder([
    ["assetHash", fixEncoderSize(getBytesEncoder(), 32)],
    ["pluginHashes", getArrayEncoder(fixEncoderSize(getBytesEncoder(), 32))]
  ]);
}
function getHashedAssetSchemaDecoder() {
  return getStructDecoder([
    ["assetHash", fixDecoderSize(getBytesDecoder(), 32)],
    ["pluginHashes", getArrayDecoder(fixDecoderSize(getBytesDecoder(), 32))]
  ]);
}
function getHashedAssetSchemaCodec() {
  return combineCodec(
    getHashedAssetSchemaEncoder(),
    getHashedAssetSchemaDecoder()
  );
}
var HookableLifecycleEvent = /* @__PURE__ */ ((HookableLifecycleEvent2) => {
  HookableLifecycleEvent2[HookableLifecycleEvent2["Create"] = 0] = "Create";
  HookableLifecycleEvent2[HookableLifecycleEvent2["Transfer"] = 1] = "Transfer";
  HookableLifecycleEvent2[HookableLifecycleEvent2["Burn"] = 2] = "Burn";
  HookableLifecycleEvent2[HookableLifecycleEvent2["Update"] = 3] = "Update";
  return HookableLifecycleEvent2;
})(HookableLifecycleEvent || {});
function getHookableLifecycleEventEncoder() {
  return getEnumEncoder(HookableLifecycleEvent);
}
function getHookableLifecycleEventDecoder() {
  return getEnumDecoder(HookableLifecycleEvent);
}
function getHookableLifecycleEventCodec() {
  return combineCodec(
    getHookableLifecycleEventEncoder(),
    getHookableLifecycleEventDecoder()
  );
}
function getImmutableMetadataEncoder() {
  return getStructEncoder([]);
}
function getImmutableMetadataDecoder() {
  return getStructDecoder([]);
}
function getImmutableMetadataCodec() {
  return combineCodec(
    getImmutableMetadataEncoder(),
    getImmutableMetadataDecoder()
  );
}
var Key = /* @__PURE__ */ ((Key2) => {
  Key2[Key2["Uninitialized"] = 0] = "Uninitialized";
  Key2[Key2["AssetV1"] = 1] = "AssetV1";
  Key2[Key2["HashedAssetV1"] = 2] = "HashedAssetV1";
  Key2[Key2["PluginHeaderV1"] = 3] = "PluginHeaderV1";
  Key2[Key2["PluginRegistryV1"] = 4] = "PluginRegistryV1";
  Key2[Key2["CollectionV1"] = 5] = "CollectionV1";
  return Key2;
})(Key || {});
function getKeyEncoder() {
  return getEnumEncoder(Key);
}
function getKeyDecoder() {
  return getEnumDecoder(Key);
}
function getKeyCodec() {
  return combineCodec(getKeyEncoder(), getKeyDecoder());
}
function getLifecycleHookEncoder() {
  return getStructEncoder([
    ["hookedProgram", getAddressEncoder()],
    [
      "extraAccounts",
      getOptionEncoder(getArrayEncoder(getExtraAccountEncoder()))
    ],
    ["dataAuthority", getOptionEncoder(getAuthorityEncoder())],
    ["schema", getExternalPluginAdapterSchemaEncoder()]
  ]);
}
function getLifecycleHookDecoder() {
  return getStructDecoder([
    ["hookedProgram", getAddressDecoder()],
    [
      "extraAccounts",
      getOptionDecoder(getArrayDecoder(getExtraAccountDecoder()))
    ],
    ["dataAuthority", getOptionDecoder(getAuthorityDecoder())],
    ["schema", getExternalPluginAdapterSchemaDecoder()]
  ]);
}
function getLifecycleHookCodec() {
  return combineCodec(getLifecycleHookEncoder(), getLifecycleHookDecoder());
}
function getLifecycleHookInitInfoEncoder() {
  return getStructEncoder([
    ["hookedProgram", getAddressEncoder()],
    ["initPluginAuthority", getOptionEncoder(getAuthorityEncoder())],
    [
      "lifecycleChecks",
      getArrayEncoder(
        getTupleEncoder([
          getHookableLifecycleEventEncoder(),
          getExternalCheckResultEncoder()
        ])
      )
    ],
    [
      "extraAccounts",
      getOptionEncoder(getArrayEncoder(getExtraAccountEncoder()))
    ],
    ["dataAuthority", getOptionEncoder(getAuthorityEncoder())],
    ["schema", getOptionEncoder(getExternalPluginAdapterSchemaEncoder())]
  ]);
}
function getLifecycleHookInitInfoDecoder() {
  return getStructDecoder([
    ["hookedProgram", getAddressDecoder()],
    ["initPluginAuthority", getOptionDecoder(getAuthorityDecoder())],
    [
      "lifecycleChecks",
      getArrayDecoder(
        getTupleDecoder([
          getHookableLifecycleEventDecoder(),
          getExternalCheckResultDecoder()
        ])
      )
    ],
    [
      "extraAccounts",
      getOptionDecoder(getArrayDecoder(getExtraAccountDecoder()))
    ],
    ["dataAuthority", getOptionDecoder(getAuthorityDecoder())],
    ["schema", getOptionDecoder(getExternalPluginAdapterSchemaDecoder())]
  ]);
}
function getLifecycleHookInitInfoCodec() {
  return combineCodec(
    getLifecycleHookInitInfoEncoder(),
    getLifecycleHookInitInfoDecoder()
  );
}
function getLifecycleHookUpdateInfoEncoder() {
  return getStructEncoder([
    [
      "lifecycleChecks",
      getOptionEncoder(
        getArrayEncoder(
          getTupleEncoder([
            getHookableLifecycleEventEncoder(),
            getExternalCheckResultEncoder()
          ])
        )
      )
    ],
    [
      "extraAccounts",
      getOptionEncoder(getArrayEncoder(getExtraAccountEncoder()))
    ],
    ["schema", getOptionEncoder(getExternalPluginAdapterSchemaEncoder())]
  ]);
}
function getLifecycleHookUpdateInfoDecoder() {
  return getStructDecoder([
    [
      "lifecycleChecks",
      getOptionDecoder(
        getArrayDecoder(
          getTupleDecoder([
            getHookableLifecycleEventDecoder(),
            getExternalCheckResultDecoder()
          ])
        )
      )
    ],
    [
      "extraAccounts",
      getOptionDecoder(getArrayDecoder(getExtraAccountDecoder()))
    ],
    ["schema", getOptionDecoder(getExternalPluginAdapterSchemaDecoder())]
  ]);
}
function getLifecycleHookUpdateInfoCodec() {
  return combineCodec(
    getLifecycleHookUpdateInfoEncoder(),
    getLifecycleHookUpdateInfoDecoder()
  );
}
function getMasterEditionEncoder() {
  return getStructEncoder([
    ["maxSupply", getOptionEncoder(getU32Encoder())],
    [
      "name",
      getOptionEncoder(addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder()))
    ],
    [
      "uri",
      getOptionEncoder(addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder()))
    ]
  ]);
}
function getMasterEditionDecoder() {
  return getStructDecoder([
    ["maxSupply", getOptionDecoder(getU32Decoder())],
    [
      "name",
      getOptionDecoder(addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder()))
    ],
    [
      "uri",
      getOptionDecoder(addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder()))
    ]
  ]);
}
function getMasterEditionCodec() {
  return combineCodec(getMasterEditionEncoder(), getMasterEditionDecoder());
}
function getOracleEncoder() {
  return getStructEncoder([
    ["baseAddress", getAddressEncoder()],
    ["baseAddressConfig", getOptionEncoder(getExtraAccountEncoder())],
    ["resultsOffset", getValidationResultsOffsetEncoder()]
  ]);
}
function getOracleDecoder() {
  return getStructDecoder([
    ["baseAddress", getAddressDecoder()],
    ["baseAddressConfig", getOptionDecoder(getExtraAccountDecoder())],
    ["resultsOffset", getValidationResultsOffsetDecoder()]
  ]);
}
function getOracleCodec() {
  return combineCodec(getOracleEncoder(), getOracleDecoder());
}
function getOracleInitInfoEncoder() {
  return getStructEncoder([
    ["baseAddress", getAddressEncoder()],
    ["initPluginAuthority", getOptionEncoder(getAuthorityEncoder())],
    [
      "lifecycleChecks",
      getArrayEncoder(
        getTupleEncoder([
          getHookableLifecycleEventEncoder(),
          getExternalCheckResultEncoder()
        ])
      )
    ],
    ["baseAddressConfig", getOptionEncoder(getExtraAccountEncoder())],
    ["resultsOffset", getOptionEncoder(getValidationResultsOffsetEncoder())]
  ]);
}
function getOracleInitInfoDecoder() {
  return getStructDecoder([
    ["baseAddress", getAddressDecoder()],
    ["initPluginAuthority", getOptionDecoder(getAuthorityDecoder())],
    [
      "lifecycleChecks",
      getArrayDecoder(
        getTupleDecoder([
          getHookableLifecycleEventDecoder(),
          getExternalCheckResultDecoder()
        ])
      )
    ],
    ["baseAddressConfig", getOptionDecoder(getExtraAccountDecoder())],
    ["resultsOffset", getOptionDecoder(getValidationResultsOffsetDecoder())]
  ]);
}
function getOracleInitInfoCodec() {
  return combineCodec(getOracleInitInfoEncoder(), getOracleInitInfoDecoder());
}
function getOracleUpdateInfoEncoder() {
  return getStructEncoder([
    [
      "lifecycleChecks",
      getOptionEncoder(
        getArrayEncoder(
          getTupleEncoder([
            getHookableLifecycleEventEncoder(),
            getExternalCheckResultEncoder()
          ])
        )
      )
    ],
    ["baseAddressConfig", getOptionEncoder(getExtraAccountEncoder())],
    ["resultsOffset", getOptionEncoder(getValidationResultsOffsetEncoder())]
  ]);
}
function getOracleUpdateInfoDecoder() {
  return getStructDecoder([
    [
      "lifecycleChecks",
      getOptionDecoder(
        getArrayDecoder(
          getTupleDecoder([
            getHookableLifecycleEventDecoder(),
            getExternalCheckResultDecoder()
          ])
        )
      )
    ],
    ["baseAddressConfig", getOptionDecoder(getExtraAccountDecoder())],
    ["resultsOffset", getOptionDecoder(getValidationResultsOffsetDecoder())]
  ]);
}
function getOracleUpdateInfoCodec() {
  return combineCodec(
    getOracleUpdateInfoEncoder(),
    getOracleUpdateInfoDecoder()
  );
}
function getOracleValidationEncoder() {
  return getDiscriminatedUnionEncoder([
    ["Uninitialized", getUnitEncoder()],
    [
      "V1",
      getStructEncoder([
        ["create", getExternalValidationResultEncoder()],
        ["transfer", getExternalValidationResultEncoder()],
        ["burn", getExternalValidationResultEncoder()],
        ["update", getExternalValidationResultEncoder()]
      ])
    ]
  ]);
}
function getOracleValidationDecoder() {
  return getDiscriminatedUnionDecoder([
    ["Uninitialized", getUnitDecoder()],
    [
      "V1",
      getStructDecoder([
        ["create", getExternalValidationResultDecoder()],
        ["transfer", getExternalValidationResultDecoder()],
        ["burn", getExternalValidationResultDecoder()],
        ["update", getExternalValidationResultDecoder()]
      ])
    ]
  ]);
}
function getOracleValidationCodec() {
  return combineCodec(
    getOracleValidationEncoder(),
    getOracleValidationDecoder()
  );
}
function oracleValidation(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isOracleValidation(kind, value) {
  return value.__kind === kind;
}
function getPermanentBurnDelegateEncoder() {
  return getStructEncoder([]);
}
function getPermanentBurnDelegateDecoder() {
  return getStructDecoder([]);
}
function getPermanentBurnDelegateCodec() {
  return combineCodec(
    getPermanentBurnDelegateEncoder(),
    getPermanentBurnDelegateDecoder()
  );
}
function getPermanentFreezeDelegateEncoder() {
  return getStructEncoder([["frozen", getBooleanEncoder()]]);
}
function getPermanentFreezeDelegateDecoder() {
  return getStructDecoder([["frozen", getBooleanDecoder()]]);
}
function getPermanentFreezeDelegateCodec() {
  return combineCodec(
    getPermanentFreezeDelegateEncoder(),
    getPermanentFreezeDelegateDecoder()
  );
}
function getPermanentTransferDelegateEncoder() {
  return getStructEncoder([]);
}
function getPermanentTransferDelegateDecoder() {
  return getStructDecoder([]);
}
function getPermanentTransferDelegateCodec() {
  return combineCodec(
    getPermanentTransferDelegateEncoder(),
    getPermanentTransferDelegateDecoder()
  );
}
function getPluginEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "Royalties",
      getStructEncoder([["fields", getTupleEncoder([getRoyaltiesEncoder()])]])
    ],
    [
      "FreezeDelegate",
      getStructEncoder([
        ["fields", getTupleEncoder([getFreezeDelegateEncoder()])]
      ])
    ],
    [
      "BurnDelegate",
      getStructEncoder([
        ["fields", getTupleEncoder([getBurnDelegateEncoder()])]
      ])
    ],
    [
      "TransferDelegate",
      getStructEncoder([
        ["fields", getTupleEncoder([getTransferDelegateEncoder()])]
      ])
    ],
    [
      "UpdateDelegate",
      getStructEncoder([
        ["fields", getTupleEncoder([getUpdateDelegateEncoder()])]
      ])
    ],
    [
      "PermanentFreezeDelegate",
      getStructEncoder([
        ["fields", getTupleEncoder([getPermanentFreezeDelegateEncoder()])]
      ])
    ],
    [
      "Attributes",
      getStructEncoder([["fields", getTupleEncoder([getAttributesEncoder()])]])
    ],
    [
      "PermanentTransferDelegate",
      getStructEncoder([
        ["fields", getTupleEncoder([getPermanentTransferDelegateEncoder()])]
      ])
    ],
    [
      "PermanentBurnDelegate",
      getStructEncoder([
        ["fields", getTupleEncoder([getPermanentBurnDelegateEncoder()])]
      ])
    ],
    [
      "Edition",
      getStructEncoder([["fields", getTupleEncoder([getEditionEncoder()])]])
    ],
    [
      "MasterEdition",
      getStructEncoder([
        ["fields", getTupleEncoder([getMasterEditionEncoder()])]
      ])
    ],
    [
      "AddBlocker",
      getStructEncoder([["fields", getTupleEncoder([getAddBlockerEncoder()])]])
    ],
    [
      "ImmutableMetadata",
      getStructEncoder([
        ["fields", getTupleEncoder([getImmutableMetadataEncoder()])]
      ])
    ],
    [
      "VerifiedCreators",
      getStructEncoder([
        ["fields", getTupleEncoder([getVerifiedCreatorsEncoder()])]
      ])
    ],
    [
      "Autograph",
      getStructEncoder([["fields", getTupleEncoder([getAutographEncoder()])]])
    ]
  ]);
}
function getPluginDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "Royalties",
      getStructDecoder([["fields", getTupleDecoder([getRoyaltiesDecoder()])]])
    ],
    [
      "FreezeDelegate",
      getStructDecoder([
        ["fields", getTupleDecoder([getFreezeDelegateDecoder()])]
      ])
    ],
    [
      "BurnDelegate",
      getStructDecoder([
        ["fields", getTupleDecoder([getBurnDelegateDecoder()])]
      ])
    ],
    [
      "TransferDelegate",
      getStructDecoder([
        ["fields", getTupleDecoder([getTransferDelegateDecoder()])]
      ])
    ],
    [
      "UpdateDelegate",
      getStructDecoder([
        ["fields", getTupleDecoder([getUpdateDelegateDecoder()])]
      ])
    ],
    [
      "PermanentFreezeDelegate",
      getStructDecoder([
        ["fields", getTupleDecoder([getPermanentFreezeDelegateDecoder()])]
      ])
    ],
    [
      "Attributes",
      getStructDecoder([["fields", getTupleDecoder([getAttributesDecoder()])]])
    ],
    [
      "PermanentTransferDelegate",
      getStructDecoder([
        ["fields", getTupleDecoder([getPermanentTransferDelegateDecoder()])]
      ])
    ],
    [
      "PermanentBurnDelegate",
      getStructDecoder([
        ["fields", getTupleDecoder([getPermanentBurnDelegateDecoder()])]
      ])
    ],
    [
      "Edition",
      getStructDecoder([["fields", getTupleDecoder([getEditionDecoder()])]])
    ],
    [
      "MasterEdition",
      getStructDecoder([
        ["fields", getTupleDecoder([getMasterEditionDecoder()])]
      ])
    ],
    [
      "AddBlocker",
      getStructDecoder([["fields", getTupleDecoder([getAddBlockerDecoder()])]])
    ],
    [
      "ImmutableMetadata",
      getStructDecoder([
        ["fields", getTupleDecoder([getImmutableMetadataDecoder()])]
      ])
    ],
    [
      "VerifiedCreators",
      getStructDecoder([
        ["fields", getTupleDecoder([getVerifiedCreatorsDecoder()])]
      ])
    ],
    [
      "Autograph",
      getStructDecoder([["fields", getTupleDecoder([getAutographDecoder()])]])
    ]
  ]);
}
function getPluginCodec() {
  return combineCodec(getPluginEncoder(), getPluginDecoder());
}
function plugin(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isPlugin(kind, value) {
  return value.__kind === kind;
}
function getPluginAuthorityPairEncoder() {
  return getStructEncoder([
    ["plugin", getPluginEncoder()],
    ["authority", getOptionEncoder(getAuthorityEncoder())]
  ]);
}
function getPluginAuthorityPairDecoder() {
  return getStructDecoder([
    ["plugin", getPluginDecoder()],
    ["authority", getOptionDecoder(getAuthorityDecoder())]
  ]);
}
function getPluginAuthorityPairCodec() {
  return combineCodec(
    getPluginAuthorityPairEncoder(),
    getPluginAuthorityPairDecoder()
  );
}
var PluginType = /* @__PURE__ */ ((PluginType3) => {
  PluginType3[PluginType3["Royalties"] = 0] = "Royalties";
  PluginType3[PluginType3["FreezeDelegate"] = 1] = "FreezeDelegate";
  PluginType3[PluginType3["BurnDelegate"] = 2] = "BurnDelegate";
  PluginType3[PluginType3["TransferDelegate"] = 3] = "TransferDelegate";
  PluginType3[PluginType3["UpdateDelegate"] = 4] = "UpdateDelegate";
  PluginType3[PluginType3["PermanentFreezeDelegate"] = 5] = "PermanentFreezeDelegate";
  PluginType3[PluginType3["Attributes"] = 6] = "Attributes";
  PluginType3[PluginType3["PermanentTransferDelegate"] = 7] = "PermanentTransferDelegate";
  PluginType3[PluginType3["PermanentBurnDelegate"] = 8] = "PermanentBurnDelegate";
  PluginType3[PluginType3["Edition"] = 9] = "Edition";
  PluginType3[PluginType3["MasterEdition"] = 10] = "MasterEdition";
  PluginType3[PluginType3["AddBlocker"] = 11] = "AddBlocker";
  PluginType3[PluginType3["ImmutableMetadata"] = 12] = "ImmutableMetadata";
  PluginType3[PluginType3["VerifiedCreators"] = 13] = "VerifiedCreators";
  PluginType3[PluginType3["Autograph"] = 14] = "Autograph";
  return PluginType3;
})(PluginType || {});
function getPluginTypeEncoder() {
  return getEnumEncoder(PluginType);
}
function getPluginTypeDecoder() {
  return getEnumDecoder(PluginType);
}
function getPluginTypeCodec() {
  return combineCodec(getPluginTypeEncoder(), getPluginTypeDecoder());
}
function getRegistryRecordEncoder() {
  return getStructEncoder([
    ["pluginType", getPluginTypeEncoder()],
    ["authority", getAuthorityEncoder()],
    ["offset", getU64Encoder()]
  ]);
}
function getRegistryRecordDecoder() {
  return getStructDecoder([
    ["pluginType", getPluginTypeDecoder()],
    ["authority", getAuthorityDecoder()],
    ["offset", getU64Decoder()]
  ]);
}
function getRegistryRecordCodec() {
  return combineCodec(getRegistryRecordEncoder(), getRegistryRecordDecoder());
}
function getRoyaltiesEncoder() {
  return getStructEncoder([
    ["basisPoints", getU16Encoder()],
    ["creators", getArrayEncoder(getCreatorEncoder())],
    ["ruleSet", getRuleSetEncoder()]
  ]);
}
function getRoyaltiesDecoder() {
  return getStructDecoder([
    ["basisPoints", getU16Decoder()],
    ["creators", getArrayDecoder(getCreatorDecoder())],
    ["ruleSet", getRuleSetDecoder()]
  ]);
}
function getRoyaltiesCodec() {
  return combineCodec(getRoyaltiesEncoder(), getRoyaltiesDecoder());
}
function getRuleSetEncoder() {
  return getDiscriminatedUnionEncoder([
    ["None", getUnitEncoder()],
    [
      "ProgramAllowList",
      getStructEncoder([
        ["fields", getTupleEncoder([getArrayEncoder(getAddressEncoder())])]
      ])
    ],
    [
      "ProgramDenyList",
      getStructEncoder([
        ["fields", getTupleEncoder([getArrayEncoder(getAddressEncoder())])]
      ])
    ]
  ]);
}
function getRuleSetDecoder() {
  return getDiscriminatedUnionDecoder([
    ["None", getUnitDecoder()],
    [
      "ProgramAllowList",
      getStructDecoder([
        ["fields", getTupleDecoder([getArrayDecoder(getAddressDecoder())])]
      ])
    ],
    [
      "ProgramDenyList",
      getStructDecoder([
        ["fields", getTupleDecoder([getArrayDecoder(getAddressDecoder())])]
      ])
    ]
  ]);
}
function getRuleSetCodec() {
  return combineCodec(getRuleSetEncoder(), getRuleSetDecoder());
}
function ruleSet(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isRuleSet(kind, value) {
  return value.__kind === kind;
}
function getSeedEncoder() {
  return getDiscriminatedUnionEncoder([
    ["Collection", getUnitEncoder()],
    ["Owner", getUnitEncoder()],
    ["Recipient", getUnitEncoder()],
    ["Asset", getUnitEncoder()],
    [
      "Address",
      getStructEncoder([["fields", getTupleEncoder([getAddressEncoder()])]])
    ],
    [
      "Bytes",
      getStructEncoder([
        [
          "fields",
          getTupleEncoder([
            addEncoderSizePrefix(getBytesEncoder(), getU32Encoder())
          ])
        ]
      ])
    ]
  ]);
}
function getSeedDecoder() {
  return getDiscriminatedUnionDecoder([
    ["Collection", getUnitDecoder()],
    ["Owner", getUnitDecoder()],
    ["Recipient", getUnitDecoder()],
    ["Asset", getUnitDecoder()],
    [
      "Address",
      getStructDecoder([["fields", getTupleDecoder([getAddressDecoder()])]])
    ],
    [
      "Bytes",
      getStructDecoder([
        [
          "fields",
          getTupleDecoder([
            addDecoderSizePrefix(getBytesDecoder(), getU32Decoder())
          ])
        ]
      ])
    ]
  ]);
}
function getSeedCodec() {
  return combineCodec(getSeedEncoder(), getSeedDecoder());
}
function seed(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isSeed(kind, value) {
  return value.__kind === kind;
}
function getTransferDelegateEncoder() {
  return getStructEncoder([]);
}
function getTransferDelegateDecoder() {
  return getStructDecoder([]);
}
function getTransferDelegateCodec() {
  return combineCodec(
    getTransferDelegateEncoder(),
    getTransferDelegateDecoder()
  );
}
function getUpdateAuthorityEncoder() {
  return getDiscriminatedUnionEncoder([
    ["None", getUnitEncoder()],
    [
      "Address",
      getStructEncoder([["fields", getTupleEncoder([getAddressEncoder()])]])
    ],
    [
      "Collection",
      getStructEncoder([["fields", getTupleEncoder([getAddressEncoder()])]])
    ]
  ]);
}
function getUpdateAuthorityDecoder() {
  return getDiscriminatedUnionDecoder([
    ["None", getUnitDecoder()],
    [
      "Address",
      getStructDecoder([["fields", getTupleDecoder([getAddressDecoder()])]])
    ],
    [
      "Collection",
      getStructDecoder([["fields", getTupleDecoder([getAddressDecoder()])]])
    ]
  ]);
}
function getUpdateAuthorityCodec() {
  return combineCodec(getUpdateAuthorityEncoder(), getUpdateAuthorityDecoder());
}
function updateAuthority(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isUpdateAuthority(kind, value) {
  return value.__kind === kind;
}
function getUpdateDelegateEncoder() {
  return getStructEncoder([
    ["additionalDelegates", getArrayEncoder(getAddressEncoder())]
  ]);
}
function getUpdateDelegateDecoder() {
  return getStructDecoder([
    ["additionalDelegates", getArrayDecoder(getAddressDecoder())]
  ]);
}
function getUpdateDelegateCodec() {
  return combineCodec(getUpdateDelegateEncoder(), getUpdateDelegateDecoder());
}
var ValidationResult = /* @__PURE__ */ ((ValidationResult2) => {
  ValidationResult2[ValidationResult2["Approved"] = 0] = "Approved";
  ValidationResult2[ValidationResult2["Rejected"] = 1] = "Rejected";
  ValidationResult2[ValidationResult2["Pass"] = 2] = "Pass";
  ValidationResult2[ValidationResult2["ForceApproved"] = 3] = "ForceApproved";
  return ValidationResult2;
})(ValidationResult || {});
function getValidationResultEncoder() {
  return getEnumEncoder(ValidationResult);
}
function getValidationResultDecoder() {
  return getEnumDecoder(ValidationResult);
}
function getValidationResultCodec() {
  return combineCodec(
    getValidationResultEncoder(),
    getValidationResultDecoder()
  );
}
function getValidationResultsOffsetEncoder() {
  return getDiscriminatedUnionEncoder([
    ["NoOffset", getUnitEncoder()],
    ["Anchor", getUnitEncoder()],
    [
      "Custom",
      getStructEncoder([["fields", getTupleEncoder([getU64Encoder()])]])
    ]
  ]);
}
function getValidationResultsOffsetDecoder() {
  return getDiscriminatedUnionDecoder([
    ["NoOffset", getUnitDecoder()],
    ["Anchor", getUnitDecoder()],
    [
      "Custom",
      getStructDecoder([["fields", getTupleDecoder([getU64Decoder()])]])
    ]
  ]);
}
function getValidationResultsOffsetCodec() {
  return combineCodec(
    getValidationResultsOffsetEncoder(),
    getValidationResultsOffsetDecoder()
  );
}
function validationResultsOffset(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isValidationResultsOffset(kind, value) {
  return value.__kind === kind;
}
function getVerifiedCreatorsEncoder() {
  return getStructEncoder([
    ["signatures", getArrayEncoder(getVerifiedCreatorsSignatureEncoder())]
  ]);
}
function getVerifiedCreatorsDecoder() {
  return getStructDecoder([
    ["signatures", getArrayDecoder(getVerifiedCreatorsSignatureDecoder())]
  ]);
}
function getVerifiedCreatorsCodec() {
  return combineCodec(
    getVerifiedCreatorsEncoder(),
    getVerifiedCreatorsDecoder()
  );
}
function getVerifiedCreatorsSignatureEncoder() {
  return getStructEncoder([
    ["address", getAddressEncoder()],
    ["verified", getBooleanEncoder()]
  ]);
}
function getVerifiedCreatorsSignatureDecoder() {
  return getStructDecoder([
    ["address", getAddressDecoder()],
    ["verified", getBooleanDecoder()]
  ]);
}
function getVerifiedCreatorsSignatureCodec() {
  return combineCodec(
    getVerifiedCreatorsSignatureEncoder(),
    getVerifiedCreatorsSignatureDecoder()
  );
}

// src/generated/accounts/assetV1.ts
function getAssetV1Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["owner", getAddressEncoder()],
    ["updateAuthority", getUpdateAuthorityEncoder()],
    ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["seq", getOptionEncoder(getU64Encoder())]
  ]);
}
function getAssetV1Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["owner", getAddressDecoder()],
    ["updateAuthority", getUpdateAuthorityDecoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["seq", getOptionDecoder(getU64Decoder())]
  ]);
}
function getAssetV1Codec() {
  return combineCodec(getAssetV1Encoder(), getAssetV1Decoder());
}
function decodeAssetV1(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getAssetV1Decoder()
  );
}
async function fetchAssetV1(rpc, address, config) {
  const maybeAccount = await fetchMaybeAssetV1(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeAssetV1(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeAssetV1(maybeAccount);
}
async function fetchAllAssetV1(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeAssetV1(rpc, addresses, config);
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeAssetV1(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeAssetV1(maybeAccount));
}
function getCollectionV1Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["updateAuthority", getAddressEncoder()],
    ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["numMinted", getU32Encoder()],
    ["currentSize", getU32Encoder()]
  ]);
}
function getCollectionV1Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["updateAuthority", getAddressDecoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["numMinted", getU32Decoder()],
    ["currentSize", getU32Decoder()]
  ]);
}
function getCollectionV1Codec() {
  return combineCodec(getCollectionV1Encoder(), getCollectionV1Decoder());
}
function decodeCollectionV1(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getCollectionV1Decoder()
  );
}
async function fetchCollectionV1(rpc, address, config) {
  const maybeAccount = await fetchMaybeCollectionV1(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeCollectionV1(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeCollectionV1(maybeAccount);
}
async function fetchAllCollectionV1(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeCollectionV1(rpc, addresses, config);
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeCollectionV1(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeCollectionV1(maybeAccount));
}
function getHashedAssetV1Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["hash", fixEncoderSize(getBytesEncoder(), 32)]
  ]);
}
function getHashedAssetV1Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["hash", fixDecoderSize(getBytesDecoder(), 32)]
  ]);
}
function getHashedAssetV1Codec() {
  return combineCodec(getHashedAssetV1Encoder(), getHashedAssetV1Decoder());
}
function decodeHashedAssetV1(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getHashedAssetV1Decoder()
  );
}
async function fetchHashedAssetV1(rpc, address, config) {
  const maybeAccount = await fetchMaybeHashedAssetV1(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeHashedAssetV1(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeHashedAssetV1(maybeAccount);
}
async function fetchAllHashedAssetV1(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeHashedAssetV1(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeHashedAssetV1(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeHashedAssetV1(maybeAccount));
}
function getHashedAssetV1Size() {
  return 33;
}
function getPluginHeaderV1Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["pluginRegistryOffset", getU64Encoder()]
  ]);
}
function getPluginHeaderV1Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["pluginRegistryOffset", getU64Decoder()]
  ]);
}
function getPluginHeaderV1Codec() {
  return combineCodec(getPluginHeaderV1Encoder(), getPluginHeaderV1Decoder());
}
function decodePluginHeaderV1(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getPluginHeaderV1Decoder()
  );
}
async function fetchPluginHeaderV1(rpc, address, config) {
  const maybeAccount = await fetchMaybePluginHeaderV1(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybePluginHeaderV1(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodePluginHeaderV1(maybeAccount);
}
async function fetchAllPluginHeaderV1(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybePluginHeaderV1(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybePluginHeaderV1(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodePluginHeaderV1(maybeAccount)
  );
}
function getPluginHeaderV1Size() {
  return 9;
}
function getPluginRegistryV1Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["registry", getArrayEncoder(getRegistryRecordEncoder())],
    ["externalRegistry", getArrayEncoder(getExternalRegistryRecordEncoder())]
  ]);
}
function getPluginRegistryV1Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["registry", getArrayDecoder(getRegistryRecordDecoder())],
    ["externalRegistry", getArrayDecoder(getExternalRegistryRecordDecoder())]
  ]);
}
function getPluginRegistryV1Codec() {
  return combineCodec(
    getPluginRegistryV1Encoder(),
    getPluginRegistryV1Decoder()
  );
}
function decodePluginRegistryV1(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getPluginRegistryV1Decoder()
  );
}
async function fetchPluginRegistryV1(rpc, address, config) {
  const maybeAccount = await fetchMaybePluginRegistryV1(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybePluginRegistryV1(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodePluginRegistryV1(maybeAccount);
}
async function fetchAllPluginRegistryV1(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybePluginRegistryV1(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybePluginRegistryV1(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodePluginRegistryV1(maybeAccount)
  );
}
var MPL_CORE_PROGRAM_PROGRAM_ADDRESS = "CoREENxT6tW1HoK8ypY1SxRMZTcVPm7R94rH4PZNhX7d";
var MplCoreProgramAccount = /* @__PURE__ */ ((MplCoreProgramAccount2) => {
  MplCoreProgramAccount2[MplCoreProgramAccount2["PluginHeaderV1"] = 0] = "PluginHeaderV1";
  MplCoreProgramAccount2[MplCoreProgramAccount2["PluginRegistryV1"] = 1] = "PluginRegistryV1";
  MplCoreProgramAccount2[MplCoreProgramAccount2["AssetV1"] = 2] = "AssetV1";
  MplCoreProgramAccount2[MplCoreProgramAccount2["CollectionV1"] = 3] = "CollectionV1";
  MplCoreProgramAccount2[MplCoreProgramAccount2["HashedAssetV1"] = 4] = "HashedAssetV1";
  return MplCoreProgramAccount2;
})(MplCoreProgramAccount || {});
var MplCoreProgramInstruction = /* @__PURE__ */ ((MplCoreProgramInstruction2) => {
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["CreateV1"] = 0] = "CreateV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["CreateCollectionV1"] = 1] = "CreateCollectionV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["AddPluginV1"] = 2] = "AddPluginV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["AddCollectionPluginV1"] = 3] = "AddCollectionPluginV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["RemovePluginV1"] = 4] = "RemovePluginV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["RemoveCollectionPluginV1"] = 5] = "RemoveCollectionPluginV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["UpdatePluginV1"] = 6] = "UpdatePluginV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["UpdateCollectionPluginV1"] = 7] = "UpdateCollectionPluginV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["ApprovePluginAuthorityV1"] = 8] = "ApprovePluginAuthorityV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["ApproveCollectionPluginAuthorityV1"] = 9] = "ApproveCollectionPluginAuthorityV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["RevokePluginAuthorityV1"] = 10] = "RevokePluginAuthorityV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["RevokeCollectionPluginAuthorityV1"] = 11] = "RevokeCollectionPluginAuthorityV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["BurnV1"] = 12] = "BurnV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["BurnCollectionV1"] = 13] = "BurnCollectionV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["TransferV1"] = 14] = "TransferV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["UpdateV1"] = 15] = "UpdateV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["UpdateCollectionV1"] = 16] = "UpdateCollectionV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["CompressV1"] = 17] = "CompressV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["DecompressV1"] = 18] = "DecompressV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["Collect"] = 19] = "Collect";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["CreateV2"] = 20] = "CreateV2";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["CreateCollectionV2"] = 21] = "CreateCollectionV2";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["AddExternalPluginAdapterV1"] = 22] = "AddExternalPluginAdapterV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["AddCollectionExternalPluginAdapterV1"] = 23] = "AddCollectionExternalPluginAdapterV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["RemoveExternalPluginAdapterV1"] = 24] = "RemoveExternalPluginAdapterV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["RemoveCollectionExternalPluginAdapterV1"] = 25] = "RemoveCollectionExternalPluginAdapterV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["UpdateExternalPluginAdapterV1"] = 26] = "UpdateExternalPluginAdapterV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["UpdateCollectionExternalPluginAdapterV1"] = 27] = "UpdateCollectionExternalPluginAdapterV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["WriteExternalPluginAdapterDataV1"] = 28] = "WriteExternalPluginAdapterDataV1";
  MplCoreProgramInstruction2[MplCoreProgramInstruction2["WriteCollectionExternalPluginAdapterDataV1"] = 29] = "WriteCollectionExternalPluginAdapterDataV1";
  return MplCoreProgramInstruction2;
})(MplCoreProgramInstruction || {});
function identifyMplCoreProgramInstruction(instruction) {
  const data = "data" in instruction ? instruction.data : instruction;
  if (containsBytes(data, getU8Encoder().encode(0), 0)) {
    return 0 /* CreateV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(1), 0)) {
    return 1 /* CreateCollectionV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(2), 0)) {
    return 2 /* AddPluginV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(3), 0)) {
    return 3 /* AddCollectionPluginV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(4), 0)) {
    return 4 /* RemovePluginV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(5), 0)) {
    return 5 /* RemoveCollectionPluginV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(6), 0)) {
    return 6 /* UpdatePluginV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(7), 0)) {
    return 7 /* UpdateCollectionPluginV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(8), 0)) {
    return 8 /* ApprovePluginAuthorityV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(9), 0)) {
    return 9 /* ApproveCollectionPluginAuthorityV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(10), 0)) {
    return 10 /* RevokePluginAuthorityV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(11), 0)) {
    return 11 /* RevokeCollectionPluginAuthorityV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(12), 0)) {
    return 12 /* BurnV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(13), 0)) {
    return 13 /* BurnCollectionV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(14), 0)) {
    return 14 /* TransferV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(15), 0)) {
    return 15 /* UpdateV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(16), 0)) {
    return 16 /* UpdateCollectionV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(17), 0)) {
    return 17 /* CompressV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(18), 0)) {
    return 18 /* DecompressV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(19), 0)) {
    return 19 /* Collect */;
  }
  if (containsBytes(data, getU8Encoder().encode(20), 0)) {
    return 20 /* CreateV2 */;
  }
  if (containsBytes(data, getU8Encoder().encode(21), 0)) {
    return 21 /* CreateCollectionV2 */;
  }
  if (containsBytes(data, getU8Encoder().encode(22), 0)) {
    return 22 /* AddExternalPluginAdapterV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(23), 0)) {
    return 23 /* AddCollectionExternalPluginAdapterV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(24), 0)) {
    return 24 /* RemoveExternalPluginAdapterV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(25), 0)) {
    return 25 /* RemoveCollectionExternalPluginAdapterV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(26), 0)) {
    return 26 /* UpdateExternalPluginAdapterV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(27), 0)) {
    return 27 /* UpdateCollectionExternalPluginAdapterV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(28), 0)) {
    return 28 /* WriteExternalPluginAdapterDataV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(29), 0)) {
    return 29 /* WriteCollectionExternalPluginAdapterDataV1 */;
  }
  throw new Error(
    "The provided instruction could not be identified as a mplCoreProgram instruction."
  );
}

// src/generated/errors/mplCoreProgram.ts
var MPL_CORE_PROGRAM_ERROR__INVALID_SYSTEM_PROGRAM = 0;
var MPL_CORE_PROGRAM_ERROR__DESERIALIZATION_ERROR = 1;
var MPL_CORE_PROGRAM_ERROR__SERIALIZATION_ERROR = 2;
var MPL_CORE_PROGRAM_ERROR__PLUGINS_NOT_INITIALIZED = 3;
var MPL_CORE_PROGRAM_ERROR__PLUGIN_NOT_FOUND = 4;
var MPL_CORE_PROGRAM_ERROR__NUMERICAL_OVERFLOW = 5;
var MPL_CORE_PROGRAM_ERROR__INCORRECT_ACCOUNT = 6;
var MPL_CORE_PROGRAM_ERROR__INCORRECT_ASSET_HASH = 7;
var MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN = 8;
var MPL_CORE_PROGRAM_ERROR__INVALID_AUTHORITY = 9;
var MPL_CORE_PROGRAM_ERROR__ASSET_IS_FROZEN = 10;
var MPL_CORE_PROGRAM_ERROR__MISSING_COMPRESSION_PROOF = 11;
var MPL_CORE_PROGRAM_ERROR__CANNOT_MIGRATE_MASTER_WITH_SUPPLY = 12;
var MPL_CORE_PROGRAM_ERROR__CANNOT_MIGRATE_PRINTS = 13;
var MPL_CORE_PROGRAM_ERROR__CANNOT_BURN_COLLECTION = 14;
var MPL_CORE_PROGRAM_ERROR__PLUGIN_ALREADY_EXISTS = 15;
var MPL_CORE_PROGRAM_ERROR__NUMERICAL_OVERFLOW_ERROR = 16;
var MPL_CORE_PROGRAM_ERROR__ALREADY_COMPRESSED = 17;
var MPL_CORE_PROGRAM_ERROR__ALREADY_DECOMPRESSED = 18;
var MPL_CORE_PROGRAM_ERROR__INVALID_COLLECTION = 19;
var MPL_CORE_PROGRAM_ERROR__MISSING_UPDATE_AUTHORITY = 20;
var MPL_CORE_PROGRAM_ERROR__MISSING_NEW_OWNER = 21;
var MPL_CORE_PROGRAM_ERROR__MISSING_SYSTEM_PROGRAM = 22;
var MPL_CORE_PROGRAM_ERROR__NOT_AVAILABLE = 23;
var MPL_CORE_PROGRAM_ERROR__INVALID_ASSET = 24;
var MPL_CORE_PROGRAM_ERROR__MISSING_COLLECTION = 25;
var MPL_CORE_PROGRAM_ERROR__NO_APPROVALS = 26;
var MPL_CORE_PROGRAM_ERROR__CANNOT_REDELEGATE = 27;
var MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN_SETTING = 28;
var MPL_CORE_PROGRAM_ERROR__CONFLICTING_AUTHORITY = 29;
var MPL_CORE_PROGRAM_ERROR__INVALID_LOG_WRAPPER_PROGRAM = 30;
var MPL_CORE_PROGRAM_ERROR__EXTERNAL_PLUGIN_ADAPTER_NOT_FOUND = 31;
var MPL_CORE_PROGRAM_ERROR__EXTERNAL_PLUGIN_ADAPTER_ALREADY_EXISTS = 32;
var MPL_CORE_PROGRAM_ERROR__MISSING_ASSET = 33;
var MPL_CORE_PROGRAM_ERROR__MISSING_EXTERNAL_PLUGIN_ADAPTER_ACCOUNT = 34;
var MPL_CORE_PROGRAM_ERROR__ORACLE_CAN_REJECT_ONLY = 35;
var MPL_CORE_PROGRAM_ERROR__REQUIRES_LIFECYCLE_CHECK = 36;
var MPL_CORE_PROGRAM_ERROR__DUPLICATE_LIFECYCLE_CHECKS = 37;
var MPL_CORE_PROGRAM_ERROR__INVALID_ORACLE_ACCOUNT_DATA = 38;
var MPL_CORE_PROGRAM_ERROR__UNINITIALIZED_ORACLE_ACCOUNT = 39;
var MPL_CORE_PROGRAM_ERROR__MISSING_SIGNER = 40;
var MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN_OPERATION = 41;
var mplCoreProgramErrorMessages;
if (process.env.NODE_ENV !== "production") {
  mplCoreProgramErrorMessages = {
    [MPL_CORE_PROGRAM_ERROR__ALREADY_COMPRESSED]: `Already compressed account`,
    [MPL_CORE_PROGRAM_ERROR__ALREADY_DECOMPRESSED]: `Already decompressed account`,
    [MPL_CORE_PROGRAM_ERROR__ASSET_IS_FROZEN]: `Cannot transfer a frozen asset`,
    [MPL_CORE_PROGRAM_ERROR__CANNOT_BURN_COLLECTION]: `Cannot burn a collection NFT`,
    [MPL_CORE_PROGRAM_ERROR__CANNOT_MIGRATE_MASTER_WITH_SUPPLY]: `Cannot migrate a master edition used for prints`,
    [MPL_CORE_PROGRAM_ERROR__CANNOT_MIGRATE_PRINTS]: `Cannot migrate a print edition`,
    [MPL_CORE_PROGRAM_ERROR__CANNOT_REDELEGATE]: `Plugin Manager cannot redelegate a delegated plugin without revoking first`,
    [MPL_CORE_PROGRAM_ERROR__CONFLICTING_AUTHORITY]: `Cannot specify both an update authority and collection on an asset`,
    [MPL_CORE_PROGRAM_ERROR__DESERIALIZATION_ERROR]: `Error deserializing account`,
    [MPL_CORE_PROGRAM_ERROR__DUPLICATE_LIFECYCLE_CHECKS]: `Duplicate lifecycle checks were provided for external plugin adapter `,
    [MPL_CORE_PROGRAM_ERROR__EXTERNAL_PLUGIN_ADAPTER_ALREADY_EXISTS]: `External PluginExternalPluginAdapter already exists`,
    [MPL_CORE_PROGRAM_ERROR__EXTERNAL_PLUGIN_ADAPTER_NOT_FOUND]: `External PluginExternalPluginAdapter not found`,
    [MPL_CORE_PROGRAM_ERROR__INCORRECT_ACCOUNT]: `Incorrect account`,
    [MPL_CORE_PROGRAM_ERROR__INCORRECT_ASSET_HASH]: `Incorrect asset hash`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_ASSET]: `Invalid Asset passed in`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_AUTHORITY]: `Invalid Authority`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_COLLECTION]: `Invalid Collection passed in`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_LOG_WRAPPER_PROGRAM]: `Invalid Log Wrapper Program`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_ORACLE_ACCOUNT_DATA]: `Could not read from oracle account`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN]: `Invalid Plugin`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN_OPERATION]: `Invalid plugin operation`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN_SETTING]: `Invalid setting for plugin`,
    [MPL_CORE_PROGRAM_ERROR__INVALID_SYSTEM_PROGRAM]: `Invalid System Program`,
    [MPL_CORE_PROGRAM_ERROR__MISSING_ASSET]: `Missing asset needed for extra account PDA derivation`,
    [MPL_CORE_PROGRAM_ERROR__MISSING_COLLECTION]: `Missing collection`,
    [MPL_CORE_PROGRAM_ERROR__MISSING_COMPRESSION_PROOF]: `Missing compression proof`,
    [MPL_CORE_PROGRAM_ERROR__MISSING_EXTERNAL_PLUGIN_ADAPTER_ACCOUNT]: `Missing account needed for external plugin adapter`,
    [MPL_CORE_PROGRAM_ERROR__MISSING_NEW_OWNER]: `Missing new owner`,
    [MPL_CORE_PROGRAM_ERROR__MISSING_SIGNER]: `Missing required signer for operation`,
    [MPL_CORE_PROGRAM_ERROR__MISSING_SYSTEM_PROGRAM]: `Missing system program`,
    [MPL_CORE_PROGRAM_ERROR__MISSING_UPDATE_AUTHORITY]: `Missing update authority`,
    [MPL_CORE_PROGRAM_ERROR__NO_APPROVALS]: `Neither the asset or any plugins have approved this operation`,
    [MPL_CORE_PROGRAM_ERROR__NOT_AVAILABLE]: `Feature not available`,
    [MPL_CORE_PROGRAM_ERROR__NUMERICAL_OVERFLOW]: `Numerical Overflow`,
    [MPL_CORE_PROGRAM_ERROR__NUMERICAL_OVERFLOW_ERROR]: `Numerical overflow`,
    [MPL_CORE_PROGRAM_ERROR__ORACLE_CAN_REJECT_ONLY]: `Oracle external plugin adapter can only be configured to reject`,
    [MPL_CORE_PROGRAM_ERROR__PLUGIN_ALREADY_EXISTS]: `Plugin already exists`,
    [MPL_CORE_PROGRAM_ERROR__PLUGIN_NOT_FOUND]: `Plugin not found`,
    [MPL_CORE_PROGRAM_ERROR__PLUGINS_NOT_INITIALIZED]: `Plugins not initialized`,
    [MPL_CORE_PROGRAM_ERROR__REQUIRES_LIFECYCLE_CHECK]: `External plugin adapter must have at least one lifecycle check`,
    [MPL_CORE_PROGRAM_ERROR__SERIALIZATION_ERROR]: `Error serializing account`,
    [MPL_CORE_PROGRAM_ERROR__UNINITIALIZED_ORACLE_ACCOUNT]: `Oracle account is uninitialized`
  };
}
function getMplCoreProgramErrorMessage(code) {
  if (process.env.NODE_ENV !== "production") {
    return mplCoreProgramErrorMessages[code];
  }
  return "Error message not available in production bundles.";
}
function isMplCoreProgramError(error, transactionMessage, code) {
  return isProgramError(
    error,
    transactionMessage,
    MPL_CORE_PROGRAM_PROGRAM_ADDRESS,
    code
  );
}
function expectAddress(value) {
  if (!value) {
    throw new Error("Expected a Address.");
  }
  if (typeof value === "object" && "address" in value) {
    return value.address;
  }
  if (Array.isArray(value)) {
    return value[0];
  }
  return value;
}
function getAccountMetaFactory(programAddress, optionalAccountStrategy) {
  return (account) => {
    if (!account.value) {
      return Object.freeze({
        address: programAddress,
        role: AccountRole.READONLY
      });
    }
    const writableRole = account.isWritable ? AccountRole.WRITABLE : AccountRole.READONLY;
    return Object.freeze({
      address: expectAddress(account.value),
      role: isTransactionSigner(account.value) ? upgradeRoleToSigner(writableRole) : writableRole,
      ...isTransactionSigner(account.value) ? { signer: account.value } : {}
    });
  };
}
function isTransactionSigner(value) {
  return !!value && typeof value === "object" && "address" in value && isTransactionSigner$1(value);
}

// src/generated/instructions/addCollectionExternalPluginAdapterV1.ts
var ADD_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR = 23;
function getAddCollectionExternalPluginAdapterV1DiscriminatorBytes() {
  return getU8Encoder().encode(
    ADD_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
  );
}
function getAddCollectionExternalPluginAdapterV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["initInfo", getExternalPluginAdapterInitInfoEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: ADD_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
    })
  );
}
function getAddCollectionExternalPluginAdapterV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["initInfo", getExternalPluginAdapterInitInfoDecoder()]
  ]);
}
function getAddCollectionExternalPluginAdapterV1InstructionDataCodec() {
  return combineCodec(
    getAddCollectionExternalPluginAdapterV1InstructionDataEncoder(),
    getAddCollectionExternalPluginAdapterV1InstructionDataDecoder()
  );
}
function getAddCollectionExternalPluginAdapterV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getAddCollectionExternalPluginAdapterV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseAddCollectionExternalPluginAdapterV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getAddCollectionExternalPluginAdapterV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var ADD_COLLECTION_PLUGIN_V1_DISCRIMINATOR = 3;
function getAddCollectionPluginV1DiscriminatorBytes() {
  return getU8Encoder().encode(ADD_COLLECTION_PLUGIN_V1_DISCRIMINATOR);
}
function getAddCollectionPluginV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["plugin", getPluginEncoder()],
      ["initAuthority", getOptionEncoder(getAuthorityEncoder())]
    ]),
    (value) => ({
      ...value,
      discriminator: ADD_COLLECTION_PLUGIN_V1_DISCRIMINATOR
    })
  );
}
function getAddCollectionPluginV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["plugin", getPluginDecoder()],
    ["initAuthority", getOptionDecoder(getAuthorityDecoder())]
  ]);
}
function getAddCollectionPluginV1InstructionDataCodec() {
  return combineCodec(
    getAddCollectionPluginV1InstructionDataEncoder(),
    getAddCollectionPluginV1InstructionDataDecoder()
  );
}
function getAddCollectionPluginV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getAddCollectionPluginV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseAddCollectionPluginV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getAddCollectionPluginV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var ADD_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR = 22;
function getAddExternalPluginAdapterV1DiscriminatorBytes() {
  return getU8Encoder().encode(ADD_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR);
}
function getAddExternalPluginAdapterV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["initInfo", getExternalPluginAdapterInitInfoEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: ADD_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
    })
  );
}
function getAddExternalPluginAdapterV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["initInfo", getExternalPluginAdapterInitInfoDecoder()]
  ]);
}
function getAddExternalPluginAdapterV1InstructionDataCodec() {
  return combineCodec(
    getAddExternalPluginAdapterV1InstructionDataEncoder(),
    getAddExternalPluginAdapterV1InstructionDataDecoder()
  );
}
function getAddExternalPluginAdapterV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getAddExternalPluginAdapterV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseAddExternalPluginAdapterV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getAddExternalPluginAdapterV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var ADD_PLUGIN_V1_DISCRIMINATOR = 2;
function getAddPluginV1DiscriminatorBytes() {
  return getU8Encoder().encode(ADD_PLUGIN_V1_DISCRIMINATOR);
}
function getAddPluginV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["plugin", getPluginEncoder()],
      ["initAuthority", getOptionEncoder(getAuthorityEncoder())]
    ]),
    (value) => ({ ...value, discriminator: ADD_PLUGIN_V1_DISCRIMINATOR })
  );
}
function getAddPluginV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["plugin", getPluginDecoder()],
    ["initAuthority", getOptionDecoder(getAuthorityDecoder())]
  ]);
}
function getAddPluginV1InstructionDataCodec() {
  return combineCodec(
    getAddPluginV1InstructionDataEncoder(),
    getAddPluginV1InstructionDataDecoder()
  );
}
function getAddPluginV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getAddPluginV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseAddPluginV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getAddPluginV1InstructionDataDecoder().decode(instruction.data)
  };
}
var APPROVE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR = 9;
function getApproveCollectionPluginAuthorityV1DiscriminatorBytes() {
  return getU8Encoder().encode(
    APPROVE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR
  );
}
function getApproveCollectionPluginAuthorityV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["pluginType", getPluginTypeEncoder()],
      ["newAuthority", getAuthorityEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: APPROVE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR
    })
  );
}
function getApproveCollectionPluginAuthorityV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["pluginType", getPluginTypeDecoder()],
    ["newAuthority", getAuthorityDecoder()]
  ]);
}
function getApproveCollectionPluginAuthorityV1InstructionDataCodec() {
  return combineCodec(
    getApproveCollectionPluginAuthorityV1InstructionDataEncoder(),
    getApproveCollectionPluginAuthorityV1InstructionDataDecoder()
  );
}
function getApproveCollectionPluginAuthorityV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getApproveCollectionPluginAuthorityV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseApproveCollectionPluginAuthorityV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getApproveCollectionPluginAuthorityV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var APPROVE_PLUGIN_AUTHORITY_V1_DISCRIMINATOR = 8;
function getApprovePluginAuthorityV1DiscriminatorBytes() {
  return getU8Encoder().encode(APPROVE_PLUGIN_AUTHORITY_V1_DISCRIMINATOR);
}
function getApprovePluginAuthorityV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["pluginType", getPluginTypeEncoder()],
      ["newAuthority", getAuthorityEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: APPROVE_PLUGIN_AUTHORITY_V1_DISCRIMINATOR
    })
  );
}
function getApprovePluginAuthorityV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["pluginType", getPluginTypeDecoder()],
    ["newAuthority", getAuthorityDecoder()]
  ]);
}
function getApprovePluginAuthorityV1InstructionDataCodec() {
  return combineCodec(
    getApprovePluginAuthorityV1InstructionDataEncoder(),
    getApprovePluginAuthorityV1InstructionDataDecoder()
  );
}
function getApprovePluginAuthorityV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getApprovePluginAuthorityV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseApprovePluginAuthorityV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getApprovePluginAuthorityV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var BURN_COLLECTION_V1_DISCRIMINATOR = 13;
function getBurnCollectionV1DiscriminatorBytes() {
  return getU8Encoder().encode(BURN_COLLECTION_V1_DISCRIMINATOR);
}
function getBurnCollectionV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["compressionProof", getOptionEncoder(getCompressionProofEncoder())]
    ]),
    (value) => ({ ...value, discriminator: BURN_COLLECTION_V1_DISCRIMINATOR })
  );
}
function getBurnCollectionV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["compressionProof", getOptionDecoder(getCompressionProofDecoder())]
  ]);
}
function getBurnCollectionV1InstructionDataCodec() {
  return combineCodec(
    getBurnCollectionV1InstructionDataEncoder(),
    getBurnCollectionV1InstructionDataDecoder()
  );
}
function getBurnCollectionV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: true },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getBurnCollectionV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseBurnCollectionV1Instruction(instruction) {
  if (instruction.accounts.length < 4) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getBurnCollectionV1InstructionDataDecoder().decode(instruction.data)
  };
}
var BURN_V1_DISCRIMINATOR = 12;
function getBurnV1DiscriminatorBytes() {
  return getU8Encoder().encode(BURN_V1_DISCRIMINATOR);
}
function getBurnV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["compressionProof", getOptionEncoder(getCompressionProofEncoder())]
    ]),
    (value) => ({ ...value, discriminator: BURN_V1_DISCRIMINATOR })
  );
}
function getBurnV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["compressionProof", getOptionDecoder(getCompressionProofDecoder())]
  ]);
}
function getBurnV1InstructionDataCodec() {
  return combineCodec(
    getBurnV1InstructionDataEncoder(),
    getBurnV1InstructionDataDecoder()
  );
}
function getBurnV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getBurnV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseBurnV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextOptionalAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getBurnV1InstructionDataDecoder().decode(instruction.data)
  };
}
var COLLECT_DISCRIMINATOR = 19;
function getCollectDiscriminatorBytes() {
  return getU8Encoder().encode(COLLECT_DISCRIMINATOR);
}
function getCollectInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: COLLECT_DISCRIMINATOR })
  );
}
function getCollectInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getCollectInstructionDataCodec() {
  return combineCodec(
    getCollectInstructionDataEncoder(),
    getCollectInstructionDataDecoder()
  );
}
function getCollectInstruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    recipient1: { value: input.recipient1 ?? null, isWritable: true },
    recipient2: { value: input.recipient2 ?? null, isWritable: true }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.recipient1),
      getAccountMeta(accounts.recipient2)
    ],
    programAddress,
    data: getCollectInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseCollectInstruction(instruction) {
  if (instruction.accounts.length < 2) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      recipient1: getNextAccount(),
      recipient2: getNextAccount()
    },
    data: getCollectInstructionDataDecoder().decode(instruction.data)
  };
}
var COMPRESS_V1_DISCRIMINATOR = 17;
function getCompressV1DiscriminatorBytes() {
  return getU8Encoder().encode(COMPRESS_V1_DISCRIMINATOR);
}
function getCompressV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: COMPRESS_V1_DISCRIMINATOR })
  );
}
function getCompressV1InstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getCompressV1InstructionDataCodec() {
  return combineCodec(
    getCompressV1InstructionDataEncoder(),
    getCompressV1InstructionDataDecoder()
  );
}
function getCompressV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getCompressV1InstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseCompressV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getCompressV1InstructionDataDecoder().decode(instruction.data)
  };
}
var CREATE_COLLECTION_V1_DISCRIMINATOR = 1;
function getCreateCollectionV1DiscriminatorBytes() {
  return getU8Encoder().encode(CREATE_COLLECTION_V1_DISCRIMINATOR);
}
function getCreateCollectionV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      [
        "plugins",
        getOptionEncoder(getArrayEncoder(getPluginAuthorityPairEncoder()))
      ]
    ]),
    (value) => ({ ...value, discriminator: CREATE_COLLECTION_V1_DISCRIMINATOR })
  );
}
function getCreateCollectionV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    [
      "plugins",
      getOptionDecoder(getArrayDecoder(getPluginAuthorityPairDecoder()))
    ]
  ]);
}
function getCreateCollectionV1InstructionDataCodec() {
  return combineCodec(
    getCreateCollectionV1InstructionDataEncoder(),
    getCreateCollectionV1InstructionDataDecoder()
  );
}
function getCreateCollectionV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram)
    ],
    programAddress,
    data: getCreateCollectionV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseCreateCollectionV1Instruction(instruction) {
  if (instruction.accounts.length < 4) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      updateAuthority: getNextOptionalAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount()
    },
    data: getCreateCollectionV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var CREATE_COLLECTION_V2_DISCRIMINATOR = 21;
function getCreateCollectionV2DiscriminatorBytes() {
  return getU8Encoder().encode(CREATE_COLLECTION_V2_DISCRIMINATOR);
}
function getCreateCollectionV2InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      [
        "plugins",
        getOptionEncoder(getArrayEncoder(getPluginAuthorityPairEncoder()))
      ],
      [
        "externalPluginAdapters",
        getOptionEncoder(
          getArrayEncoder(getExternalPluginAdapterInitInfoEncoder())
        )
      ]
    ]),
    (value) => ({ ...value, discriminator: CREATE_COLLECTION_V2_DISCRIMINATOR })
  );
}
function getCreateCollectionV2InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    [
      "plugins",
      getOptionDecoder(getArrayDecoder(getPluginAuthorityPairDecoder()))
    ],
    [
      "externalPluginAdapters",
      getOptionDecoder(
        getArrayDecoder(getExternalPluginAdapterInitInfoDecoder())
      )
    ]
  ]);
}
function getCreateCollectionV2InstructionDataCodec() {
  return combineCodec(
    getCreateCollectionV2InstructionDataEncoder(),
    getCreateCollectionV2InstructionDataDecoder()
  );
}
function getCreateCollectionV2Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram)
    ],
    programAddress,
    data: getCreateCollectionV2InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseCreateCollectionV2Instruction(instruction) {
  if (instruction.accounts.length < 4) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      updateAuthority: getNextOptionalAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount()
    },
    data: getCreateCollectionV2InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var CREATE_V1_DISCRIMINATOR = 0;
function getCreateV1DiscriminatorBytes() {
  return getU8Encoder().encode(CREATE_V1_DISCRIMINATOR);
}
function getCreateV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["dataState", getDataStateEncoder()],
      ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      [
        "plugins",
        getOptionEncoder(getArrayEncoder(getPluginAuthorityPairEncoder()))
      ]
    ]),
    (value) => ({ ...value, discriminator: CREATE_V1_DISCRIMINATOR })
  );
}
function getCreateV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["dataState", getDataStateDecoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    [
      "plugins",
      getOptionDecoder(getArrayDecoder(getPluginAuthorityPairDecoder()))
    ]
  ]);
}
function getCreateV1InstructionDataCodec() {
  return combineCodec(
    getCreateV1InstructionDataEncoder(),
    getCreateV1InstructionDataDecoder()
  );
}
function getCreateV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    owner: { value: input.owner ?? null, isWritable: false },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.owner),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getCreateV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseCreateV1Instruction(instruction) {
  if (instruction.accounts.length < 8) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      authority: getNextOptionalAccount(),
      payer: getNextAccount(),
      owner: getNextOptionalAccount(),
      updateAuthority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getCreateV1InstructionDataDecoder().decode(instruction.data)
  };
}
var CREATE_V2_DISCRIMINATOR = 20;
function getCreateV2DiscriminatorBytes() {
  return getU8Encoder().encode(CREATE_V2_DISCRIMINATOR);
}
function getCreateV2InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["dataState", getDataStateEncoder()],
      ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      [
        "plugins",
        getOptionEncoder(getArrayEncoder(getPluginAuthorityPairEncoder()))
      ],
      [
        "externalPluginAdapters",
        getOptionEncoder(
          getArrayEncoder(getExternalPluginAdapterInitInfoEncoder())
        )
      ]
    ]),
    (value) => ({ ...value, discriminator: CREATE_V2_DISCRIMINATOR })
  );
}
function getCreateV2InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["dataState", getDataStateDecoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    [
      "plugins",
      getOptionDecoder(getArrayDecoder(getPluginAuthorityPairDecoder()))
    ],
    [
      "externalPluginAdapters",
      getOptionDecoder(
        getArrayDecoder(getExternalPluginAdapterInitInfoDecoder())
      )
    ]
  ]);
}
function getCreateV2InstructionDataCodec() {
  return combineCodec(
    getCreateV2InstructionDataEncoder(),
    getCreateV2InstructionDataDecoder()
  );
}
function getCreateV2Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    owner: { value: input.owner ?? null, isWritable: false },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.owner),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getCreateV2InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseCreateV2Instruction(instruction) {
  if (instruction.accounts.length < 8) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      authority: getNextOptionalAccount(),
      payer: getNextAccount(),
      owner: getNextOptionalAccount(),
      updateAuthority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getCreateV2InstructionDataDecoder().decode(instruction.data)
  };
}
var DECOMPRESS_V1_DISCRIMINATOR = 18;
function getDecompressV1DiscriminatorBytes() {
  return getU8Encoder().encode(DECOMPRESS_V1_DISCRIMINATOR);
}
function getDecompressV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["compressionProof", getCompressionProofEncoder()]
    ]),
    (value) => ({ ...value, discriminator: DECOMPRESS_V1_DISCRIMINATOR })
  );
}
function getDecompressV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["compressionProof", getCompressionProofDecoder()]
  ]);
}
function getDecompressV1InstructionDataCodec() {
  return combineCodec(
    getDecompressV1InstructionDataEncoder(),
    getDecompressV1InstructionDataDecoder()
  );
}
function getDecompressV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getDecompressV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseDecompressV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getDecompressV1InstructionDataDecoder().decode(instruction.data)
  };
}
var REMOVE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR = 25;
function getRemoveCollectionExternalPluginAdapterV1DiscriminatorBytes() {
  return getU8Encoder().encode(
    REMOVE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
  );
}
function getRemoveCollectionExternalPluginAdapterV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["key", getExternalPluginAdapterKeyEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: REMOVE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
    })
  );
}
function getRemoveCollectionExternalPluginAdapterV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["key", getExternalPluginAdapterKeyDecoder()]
  ]);
}
function getRemoveCollectionExternalPluginAdapterV1InstructionDataCodec() {
  return combineCodec(
    getRemoveCollectionExternalPluginAdapterV1InstructionDataEncoder(),
    getRemoveCollectionExternalPluginAdapterV1InstructionDataDecoder()
  );
}
function getRemoveCollectionExternalPluginAdapterV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getRemoveCollectionExternalPluginAdapterV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseRemoveCollectionExternalPluginAdapterV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getRemoveCollectionExternalPluginAdapterV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var REMOVE_COLLECTION_PLUGIN_V1_DISCRIMINATOR = 5;
function getRemoveCollectionPluginV1DiscriminatorBytes() {
  return getU8Encoder().encode(REMOVE_COLLECTION_PLUGIN_V1_DISCRIMINATOR);
}
function getRemoveCollectionPluginV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["pluginType", getPluginTypeEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: REMOVE_COLLECTION_PLUGIN_V1_DISCRIMINATOR
    })
  );
}
function getRemoveCollectionPluginV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["pluginType", getPluginTypeDecoder()]
  ]);
}
function getRemoveCollectionPluginV1InstructionDataCodec() {
  return combineCodec(
    getRemoveCollectionPluginV1InstructionDataEncoder(),
    getRemoveCollectionPluginV1InstructionDataDecoder()
  );
}
function getRemoveCollectionPluginV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getRemoveCollectionPluginV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseRemoveCollectionPluginV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getRemoveCollectionPluginV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var REMOVE_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR = 24;
function getRemoveExternalPluginAdapterV1DiscriminatorBytes() {
  return getU8Encoder().encode(REMOVE_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR);
}
function getRemoveExternalPluginAdapterV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["key", getExternalPluginAdapterKeyEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: REMOVE_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
    })
  );
}
function getRemoveExternalPluginAdapterV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["key", getExternalPluginAdapterKeyDecoder()]
  ]);
}
function getRemoveExternalPluginAdapterV1InstructionDataCodec() {
  return combineCodec(
    getRemoveExternalPluginAdapterV1InstructionDataEncoder(),
    getRemoveExternalPluginAdapterV1InstructionDataDecoder()
  );
}
function getRemoveExternalPluginAdapterV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getRemoveExternalPluginAdapterV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseRemoveExternalPluginAdapterV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getRemoveExternalPluginAdapterV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var REMOVE_PLUGIN_V1_DISCRIMINATOR = 4;
function getRemovePluginV1DiscriminatorBytes() {
  return getU8Encoder().encode(REMOVE_PLUGIN_V1_DISCRIMINATOR);
}
function getRemovePluginV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["pluginType", getPluginTypeEncoder()]
    ]),
    (value) => ({ ...value, discriminator: REMOVE_PLUGIN_V1_DISCRIMINATOR })
  );
}
function getRemovePluginV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["pluginType", getPluginTypeDecoder()]
  ]);
}
function getRemovePluginV1InstructionDataCodec() {
  return combineCodec(
    getRemovePluginV1InstructionDataEncoder(),
    getRemovePluginV1InstructionDataDecoder()
  );
}
function getRemovePluginV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getRemovePluginV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseRemovePluginV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getRemovePluginV1InstructionDataDecoder().decode(instruction.data)
  };
}
var REVOKE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR = 11;
function getRevokeCollectionPluginAuthorityV1DiscriminatorBytes() {
  return getU8Encoder().encode(
    REVOKE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR
  );
}
function getRevokeCollectionPluginAuthorityV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["pluginType", getPluginTypeEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: REVOKE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR
    })
  );
}
function getRevokeCollectionPluginAuthorityV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["pluginType", getPluginTypeDecoder()]
  ]);
}
function getRevokeCollectionPluginAuthorityV1InstructionDataCodec() {
  return combineCodec(
    getRevokeCollectionPluginAuthorityV1InstructionDataEncoder(),
    getRevokeCollectionPluginAuthorityV1InstructionDataDecoder()
  );
}
function getRevokeCollectionPluginAuthorityV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getRevokeCollectionPluginAuthorityV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseRevokeCollectionPluginAuthorityV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getRevokeCollectionPluginAuthorityV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var REVOKE_PLUGIN_AUTHORITY_V1_DISCRIMINATOR = 10;
function getRevokePluginAuthorityV1DiscriminatorBytes() {
  return getU8Encoder().encode(REVOKE_PLUGIN_AUTHORITY_V1_DISCRIMINATOR);
}
function getRevokePluginAuthorityV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["pluginType", getPluginTypeEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: REVOKE_PLUGIN_AUTHORITY_V1_DISCRIMINATOR
    })
  );
}
function getRevokePluginAuthorityV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["pluginType", getPluginTypeDecoder()]
  ]);
}
function getRevokePluginAuthorityV1InstructionDataCodec() {
  return combineCodec(
    getRevokePluginAuthorityV1InstructionDataEncoder(),
    getRevokePluginAuthorityV1InstructionDataDecoder()
  );
}
function getRevokePluginAuthorityV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getRevokePluginAuthorityV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseRevokePluginAuthorityV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getRevokePluginAuthorityV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var TRANSFER_V1_DISCRIMINATOR = 14;
function getTransferV1DiscriminatorBytes() {
  return getU8Encoder().encode(TRANSFER_V1_DISCRIMINATOR);
}
function getTransferV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["compressionProof", getOptionEncoder(getCompressionProofEncoder())]
    ]),
    (value) => ({ ...value, discriminator: TRANSFER_V1_DISCRIMINATOR })
  );
}
function getTransferV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["compressionProof", getOptionDecoder(getCompressionProofDecoder())]
  ]);
}
function getTransferV1InstructionDataCodec() {
  return combineCodec(
    getTransferV1InstructionDataEncoder(),
    getTransferV1InstructionDataDecoder()
  );
}
function getTransferV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    newOwner: { value: input.newOwner ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.newOwner),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getTransferV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseTransferV1Instruction(instruction) {
  if (instruction.accounts.length < 7) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      newOwner: getNextAccount(),
      systemProgram: getNextOptionalAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getTransferV1InstructionDataDecoder().decode(instruction.data)
  };
}
var UPDATE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR = 27;
function getUpdateCollectionExternalPluginAdapterV1DiscriminatorBytes() {
  return getU8Encoder().encode(
    UPDATE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
  );
}
function getUpdateCollectionExternalPluginAdapterV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["key", getExternalPluginAdapterKeyEncoder()],
      ["updateInfo", getExternalPluginAdapterUpdateInfoEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: UPDATE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
    })
  );
}
function getUpdateCollectionExternalPluginAdapterV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["key", getExternalPluginAdapterKeyDecoder()],
    ["updateInfo", getExternalPluginAdapterUpdateInfoDecoder()]
  ]);
}
function getUpdateCollectionExternalPluginAdapterV1InstructionDataCodec() {
  return combineCodec(
    getUpdateCollectionExternalPluginAdapterV1InstructionDataEncoder(),
    getUpdateCollectionExternalPluginAdapterV1InstructionDataDecoder()
  );
}
function getUpdateCollectionExternalPluginAdapterV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getUpdateCollectionExternalPluginAdapterV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUpdateCollectionExternalPluginAdapterV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getUpdateCollectionExternalPluginAdapterV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var UPDATE_COLLECTION_PLUGIN_V1_DISCRIMINATOR = 7;
function getUpdateCollectionPluginV1DiscriminatorBytes() {
  return getU8Encoder().encode(UPDATE_COLLECTION_PLUGIN_V1_DISCRIMINATOR);
}
function getUpdateCollectionPluginV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["plugin", getPluginEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: UPDATE_COLLECTION_PLUGIN_V1_DISCRIMINATOR
    })
  );
}
function getUpdateCollectionPluginV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["plugin", getPluginDecoder()]
  ]);
}
function getUpdateCollectionPluginV1InstructionDataCodec() {
  return combineCodec(
    getUpdateCollectionPluginV1InstructionDataEncoder(),
    getUpdateCollectionPluginV1InstructionDataDecoder()
  );
}
function getUpdateCollectionPluginV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getUpdateCollectionPluginV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUpdateCollectionPluginV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getUpdateCollectionPluginV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var UPDATE_COLLECTION_V1_DISCRIMINATOR = 16;
function getUpdateCollectionV1DiscriminatorBytes() {
  return getU8Encoder().encode(UPDATE_COLLECTION_V1_DISCRIMINATOR);
}
function getUpdateCollectionV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      [
        "newName",
        getOptionEncoder(
          addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())
        )
      ],
      [
        "newUri",
        getOptionEncoder(
          addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())
        )
      ]
    ]),
    (value) => ({ ...value, discriminator: UPDATE_COLLECTION_V1_DISCRIMINATOR })
  );
}
function getUpdateCollectionV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    [
      "newName",
      getOptionDecoder(addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder()))
    ],
    [
      "newUri",
      getOptionDecoder(addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder()))
    ]
  ]);
}
function getUpdateCollectionV1InstructionDataCodec() {
  return combineCodec(
    getUpdateCollectionV1InstructionDataEncoder(),
    getUpdateCollectionV1InstructionDataDecoder()
  );
}
function getUpdateCollectionV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    newUpdateAuthority: {
      value: input.newUpdateAuthority ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.newUpdateAuthority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getUpdateCollectionV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUpdateCollectionV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      newUpdateAuthority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getUpdateCollectionV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var UPDATE_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR = 26;
function getUpdateExternalPluginAdapterV1DiscriminatorBytes() {
  return getU8Encoder().encode(UPDATE_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR);
}
function getUpdateExternalPluginAdapterV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["key", getExternalPluginAdapterKeyEncoder()],
      ["updateInfo", getExternalPluginAdapterUpdateInfoEncoder()]
    ]),
    (value) => ({
      ...value,
      discriminator: UPDATE_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR
    })
  );
}
function getUpdateExternalPluginAdapterV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["key", getExternalPluginAdapterKeyDecoder()],
    ["updateInfo", getExternalPluginAdapterUpdateInfoDecoder()]
  ]);
}
function getUpdateExternalPluginAdapterV1InstructionDataCodec() {
  return combineCodec(
    getUpdateExternalPluginAdapterV1InstructionDataEncoder(),
    getUpdateExternalPluginAdapterV1InstructionDataDecoder()
  );
}
function getUpdateExternalPluginAdapterV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getUpdateExternalPluginAdapterV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUpdateExternalPluginAdapterV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getUpdateExternalPluginAdapterV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var UPDATE_PLUGIN_V1_DISCRIMINATOR = 6;
function getUpdatePluginV1DiscriminatorBytes() {
  return getU8Encoder().encode(UPDATE_PLUGIN_V1_DISCRIMINATOR);
}
function getUpdatePluginV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["plugin", getPluginEncoder()]
    ]),
    (value) => ({ ...value, discriminator: UPDATE_PLUGIN_V1_DISCRIMINATOR })
  );
}
function getUpdatePluginV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["plugin", getPluginDecoder()]
  ]);
}
function getUpdatePluginV1InstructionDataCodec() {
  return combineCodec(
    getUpdatePluginV1InstructionDataEncoder(),
    getUpdatePluginV1InstructionDataDecoder()
  );
}
function getUpdatePluginV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getUpdatePluginV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUpdatePluginV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getUpdatePluginV1InstructionDataDecoder().decode(instruction.data)
  };
}
var UPDATE_V1_DISCRIMINATOR = 15;
function getUpdateV1DiscriminatorBytes() {
  return getU8Encoder().encode(UPDATE_V1_DISCRIMINATOR);
}
function getUpdateV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      [
        "newName",
        getOptionEncoder(
          addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())
        )
      ],
      [
        "newUri",
        getOptionEncoder(
          addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())
        )
      ],
      ["newUpdateAuthority", getOptionEncoder(getUpdateAuthorityEncoder())]
    ]),
    (value) => ({ ...value, discriminator: UPDATE_V1_DISCRIMINATOR })
  );
}
function getUpdateV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    [
      "newName",
      getOptionDecoder(addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder()))
    ],
    [
      "newUri",
      getOptionDecoder(addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder()))
    ],
    ["newUpdateAuthority", getOptionDecoder(getUpdateAuthorityDecoder())]
  ]);
}
function getUpdateV1InstructionDataCodec() {
  return combineCodec(
    getUpdateV1InstructionDataEncoder(),
    getUpdateV1InstructionDataDecoder()
  );
}
function getUpdateV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getUpdateV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUpdateV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getUpdateV1InstructionDataDecoder().decode(instruction.data)
  };
}
var WRITE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_DATA_V1_DISCRIMINATOR = 29;
function getWriteCollectionExternalPluginAdapterDataV1DiscriminatorBytes() {
  return getU8Encoder().encode(
    WRITE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_DATA_V1_DISCRIMINATOR
  );
}
function getWriteCollectionExternalPluginAdapterDataV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["key", getExternalPluginAdapterKeyEncoder()],
      ["data", addEncoderSizePrefix(getBytesEncoder(), getU32Encoder())]
    ]),
    (value) => ({
      ...value,
      discriminator: WRITE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_DATA_V1_DISCRIMINATOR
    })
  );
}
function getWriteCollectionExternalPluginAdapterDataV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["key", getExternalPluginAdapterKeyDecoder()],
    ["data", addDecoderSizePrefix(getBytesDecoder(), getU32Decoder())]
  ]);
}
function getWriteCollectionExternalPluginAdapterDataV1InstructionDataCodec() {
  return combineCodec(
    getWriteCollectionExternalPluginAdapterDataV1InstructionDataEncoder(),
    getWriteCollectionExternalPluginAdapterDataV1InstructionDataDecoder()
  );
}
function getWriteCollectionExternalPluginAdapterDataV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getWriteCollectionExternalPluginAdapterDataV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseWriteCollectionExternalPluginAdapterDataV1Instruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collection: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getWriteCollectionExternalPluginAdapterDataV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var WRITE_EXTERNAL_PLUGIN_ADAPTER_DATA_V1_DISCRIMINATOR = 28;
function getWriteExternalPluginAdapterDataV1DiscriminatorBytes() {
  return getU8Encoder().encode(
    WRITE_EXTERNAL_PLUGIN_ADAPTER_DATA_V1_DISCRIMINATOR
  );
}
function getWriteExternalPluginAdapterDataV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["key", getExternalPluginAdapterKeyEncoder()],
      ["data", addEncoderSizePrefix(getBytesEncoder(), getU32Encoder())]
    ]),
    (value) => ({
      ...value,
      discriminator: WRITE_EXTERNAL_PLUGIN_ADAPTER_DATA_V1_DISCRIMINATOR
    })
  );
}
function getWriteExternalPluginAdapterDataV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["key", getExternalPluginAdapterKeyDecoder()],
    ["data", addDecoderSizePrefix(getBytesDecoder(), getU32Decoder())]
  ]);
}
function getWriteExternalPluginAdapterDataV1InstructionDataCodec() {
  return combineCodec(
    getWriteExternalPluginAdapterDataV1InstructionDataEncoder(),
    getWriteExternalPluginAdapterDataV1InstructionDataDecoder()
  );
}
function getWriteExternalPluginAdapterDataV1Instruction(input, config) {
  const programAddress = config?.programAddress ?? MPL_CORE_PROGRAM_PROGRAM_ADDRESS;
  const originalAccounts = {
    asset: { value: input.asset ?? null, isWritable: true },
    collection: { value: input.collection ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    logWrapper: { value: input.logWrapper ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress);
  const instruction = {
    accounts: [
      getAccountMeta(accounts.asset),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.logWrapper)
    ],
    programAddress,
    data: getWriteExternalPluginAdapterDataV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseWriteExternalPluginAdapterDataV1Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === MPL_CORE_PROGRAM_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      asset: getNextAccount(),
      collection: getNextOptionalAccount(),
      payer: getNextAccount(),
      authority: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      logWrapper: getNextOptionalAccount()
    },
    data: getWriteExternalPluginAdapterDataV1InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var createAsset = async (args) => {
  const {
    client,
    payer,
    authority: authority2,
    updateAuthority: updateAuthority2,
    owner,
    name,
    uri,
    plugins,
    collection,
    asset_kp = await generateKeyPairSigner()
  } = args;
  if (collection && updateAuthority2)
    throw new Error("Cannot specify both collection and updateAuthority");
  const ix = getCreateV2Instruction({
    asset: asset_kp,
    payer,
    owner,
    authority: authority2,
    updateAuthority: updateAuthority2,
    collection,
    dataState: 0 /* AccountState */,
    name,
    uri,
    plugins,
    externalPluginAdapters: null
  });
  const signature = await pipe(
    await createDefaultTransaction(client, payer),
    (tx) => appendTransactionMessageInstruction(ix, tx),
    (tx) => signAndSendTransaction(client, tx)
  );
  return { signature, address: asset_kp.address };
};
var createDefaultAsset = async (args) => {
  const {
    client,
    payer,
    authority: authority2,
    updateAuthority: updateAuthority2,
    owner,
    royalties,
    collection,
    name,
    uri
  } = args;
  let plugins = null;
  if (royalties) {
    const royalty = [
      {
        basisPoints: royalties.basisPoints ?? 500,
        creators: royalties.creators ?? [],
        ruleSet: {
          __kind: "None"
        }
      }
    ];
    plugins = [
      {
        plugin: {
          __kind: "Royalties",
          fields: royalty
        },
        authority: { __kind: "UpdateAuthority" }
      }
    ];
  }
  const { address } = await createAsset({
    client,
    payer,
    authority: authority2,
    updateAuthority: updateAuthority2,
    owner,
    name: name ?? "TestAsset",
    uri: uri ?? "https://example.com/nft",
    plugins,
    collection
  });
  return await fetchAssetV1(client.rpc, address);
};
var createCollection = async (args) => {
  const {
    client,
    payer,
    updateAuthority: updateAuthority2,
    plugins,
    collection_kp = await generateKeyPairSigner()
  } = args;
  const createCollectionIx = getCreateCollectionV1Instruction({
    collection: collection_kp,
    payer,
    updateAuthority: updateAuthority2,
    name: "TestCollection",
    uri: "https://example.com/collection",
    plugins
  });
  const signature = await pipe(
    await createDefaultTransaction(client, payer),
    (tx) => appendTransactionMessageInstruction(createCollectionIx, tx),
    (tx) => signAndSendTransaction(client, tx)
  );
  return { signature, address: collection_kp.address };
};
var createDefaultCollection = async (args) => {
  const {
    client,
    payer,
    updateAuthority: updateAuthority2,
    royalties = {
      creators: [
        {
          address: updateAuthority2,
          percentage: 100
        }
      ],
      basisPoints: 500
    }
  } = args;
  const royaltyArgs = [
    {
      basisPoints: royalties.basisPoints,
      creators: royalties.creators,
      ruleSet: {
        __kind: "None"
      }
    }
  ];
  const plugins = [
    {
      plugin: {
        __kind: "Royalties",
        fields: royaltyArgs
      },
      authority: { __kind: "UpdateAuthority" }
    }
  ];
  const { address } = await createCollection({
    client,
    payer,
    updateAuthority: updateAuthority2,
    plugins
  });
  return await fetchCollectionV1(client.rpc, address);
};
var createDefaultAssetWithCollection = async (args) => {
  const { client, payer, collectionAuthority, owner, royalties } = args;
  const collection = await createDefaultCollection({
    client,
    payer,
    updateAuthority: collectionAuthority.address,
    royalties
  });
  const asset = await createDefaultAsset({
    client,
    payer,
    owner,
    authority: collectionAuthority,
    collection: collection.address
  });
  return [asset, collection];
};

// src/helpers/fetchPlugins.ts
var BASE_ASSET_SIZE = 75;
var BASE_COLLECTION_SIZE = 49;
async function fetchAssetPlugin(client, address, pluginType) {
  const data = (await client.rpc.getAccountInfo(address, { encoding: "base64" }).send()).value.data;
  const buffer = new Uint8Array(Buffer.from(String(data), "base64"));
  const asset = getAssetV1Decoder().decode(buffer);
  const assetSize = BASE_ASSET_SIZE + asset.name.length + asset.uri.length;
  const header = getPluginHeaderV1Decoder().decode(buffer.subarray(assetSize));
  const pluginRegistry = getPluginRegistryV1Decoder().decode(
    buffer.subarray(Number(header.pluginRegistryOffset))
  );
  const pluginRecord = pluginRegistry.registry.find(
    (plugin3) => plugin3.pluginType === pluginType
  );
  if (!pluginRecord) {
    return null;
  }
  const plugin2 = getPluginDecoder().decode(
    buffer,
    Number(pluginRecord.offset)
  );
  return plugin2;
}
async function fetchCollectionPlugin(client, address, pluginType) {
  const data = (await client.rpc.getAccountInfo(address, { encoding: "base64" }).send()).value.data;
  const buffer = new Uint8Array(Buffer.from(String(data), "base64"));
  const collection = getCollectionV1Decoder().decode(buffer);
  const collectionSize = BASE_COLLECTION_SIZE + collection.name.length + collection.uri.length;
  const header = getPluginHeaderV1Decoder().decode(
    buffer.subarray(collectionSize)
  );
  const pluginRegistry = getPluginRegistryV1Decoder().decode(
    buffer.subarray(Number(header.pluginRegistryOffset))
  );
  const pluginRecord = pluginRegistry.registry.find(
    (plugin3) => plugin3.pluginType === pluginType
  );
  if (!pluginRecord) {
    return null;
  }
  const plugin2 = getPluginDecoder().decode(
    buffer,
    Number(pluginRecord.offset)
  );
  return plugin2;
}

export { ADD_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR, ADD_COLLECTION_PLUGIN_V1_DISCRIMINATOR, ADD_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR, ADD_PLUGIN_V1_DISCRIMINATOR, APPROVE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR, APPROVE_PLUGIN_AUTHORITY_V1_DISCRIMINATOR, BURN_COLLECTION_V1_DISCRIMINATOR, BURN_V1_DISCRIMINATOR, COLLECT_DISCRIMINATOR, COMPRESS_V1_DISCRIMINATOR, CREATE_COLLECTION_V1_DISCRIMINATOR, CREATE_COLLECTION_V2_DISCRIMINATOR, CREATE_V1_DISCRIMINATOR, CREATE_V2_DISCRIMINATOR, DECOMPRESS_V1_DISCRIMINATOR, DataState, ExternalPluginAdapterSchema, ExternalPluginAdapterType, ExternalValidationResult, HookableLifecycleEvent, Key, MPL_CORE_PROGRAM_ERROR__ALREADY_COMPRESSED, MPL_CORE_PROGRAM_ERROR__ALREADY_DECOMPRESSED, MPL_CORE_PROGRAM_ERROR__ASSET_IS_FROZEN, MPL_CORE_PROGRAM_ERROR__CANNOT_BURN_COLLECTION, MPL_CORE_PROGRAM_ERROR__CANNOT_MIGRATE_MASTER_WITH_SUPPLY, MPL_CORE_PROGRAM_ERROR__CANNOT_MIGRATE_PRINTS, MPL_CORE_PROGRAM_ERROR__CANNOT_REDELEGATE, MPL_CORE_PROGRAM_ERROR__CONFLICTING_AUTHORITY, MPL_CORE_PROGRAM_ERROR__DESERIALIZATION_ERROR, MPL_CORE_PROGRAM_ERROR__DUPLICATE_LIFECYCLE_CHECKS, MPL_CORE_PROGRAM_ERROR__EXTERNAL_PLUGIN_ADAPTER_ALREADY_EXISTS, MPL_CORE_PROGRAM_ERROR__EXTERNAL_PLUGIN_ADAPTER_NOT_FOUND, MPL_CORE_PROGRAM_ERROR__INCORRECT_ACCOUNT, MPL_CORE_PROGRAM_ERROR__INCORRECT_ASSET_HASH, MPL_CORE_PROGRAM_ERROR__INVALID_ASSET, MPL_CORE_PROGRAM_ERROR__INVALID_AUTHORITY, MPL_CORE_PROGRAM_ERROR__INVALID_COLLECTION, MPL_CORE_PROGRAM_ERROR__INVALID_LOG_WRAPPER_PROGRAM, MPL_CORE_PROGRAM_ERROR__INVALID_ORACLE_ACCOUNT_DATA, MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN, MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN_OPERATION, MPL_CORE_PROGRAM_ERROR__INVALID_PLUGIN_SETTING, MPL_CORE_PROGRAM_ERROR__INVALID_SYSTEM_PROGRAM, MPL_CORE_PROGRAM_ERROR__MISSING_ASSET, MPL_CORE_PROGRAM_ERROR__MISSING_COLLECTION, MPL_CORE_PROGRAM_ERROR__MISSING_COMPRESSION_PROOF, MPL_CORE_PROGRAM_ERROR__MISSING_EXTERNAL_PLUGIN_ADAPTER_ACCOUNT, MPL_CORE_PROGRAM_ERROR__MISSING_NEW_OWNER, MPL_CORE_PROGRAM_ERROR__MISSING_SIGNER, MPL_CORE_PROGRAM_ERROR__MISSING_SYSTEM_PROGRAM, MPL_CORE_PROGRAM_ERROR__MISSING_UPDATE_AUTHORITY, MPL_CORE_PROGRAM_ERROR__NOT_AVAILABLE, MPL_CORE_PROGRAM_ERROR__NO_APPROVALS, MPL_CORE_PROGRAM_ERROR__NUMERICAL_OVERFLOW, MPL_CORE_PROGRAM_ERROR__NUMERICAL_OVERFLOW_ERROR, MPL_CORE_PROGRAM_ERROR__ORACLE_CAN_REJECT_ONLY, MPL_CORE_PROGRAM_ERROR__PLUGINS_NOT_INITIALIZED, MPL_CORE_PROGRAM_ERROR__PLUGIN_ALREADY_EXISTS, MPL_CORE_PROGRAM_ERROR__PLUGIN_NOT_FOUND, MPL_CORE_PROGRAM_ERROR__REQUIRES_LIFECYCLE_CHECK, MPL_CORE_PROGRAM_ERROR__SERIALIZATION_ERROR, MPL_CORE_PROGRAM_ERROR__UNINITIALIZED_ORACLE_ACCOUNT, MPL_CORE_PROGRAM_PROGRAM_ADDRESS, MplCoreProgramAccount, MplCoreProgramInstruction, PluginType, REMOVE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR, REMOVE_COLLECTION_PLUGIN_V1_DISCRIMINATOR, REMOVE_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR, REMOVE_PLUGIN_V1_DISCRIMINATOR, REVOKE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR, REVOKE_PLUGIN_AUTHORITY_V1_DISCRIMINATOR, TRANSFER_V1_DISCRIMINATOR, UPDATE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR, UPDATE_COLLECTION_PLUGIN_V1_DISCRIMINATOR, UPDATE_COLLECTION_V1_DISCRIMINATOR, UPDATE_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR, UPDATE_PLUGIN_V1_DISCRIMINATOR, UPDATE_V1_DISCRIMINATOR, ValidationResult, WRITE_COLLECTION_EXTERNAL_PLUGIN_ADAPTER_DATA_V1_DISCRIMINATOR, WRITE_EXTERNAL_PLUGIN_ADAPTER_DATA_V1_DISCRIMINATOR, authority, createAsset, createCollection, createDefaultAsset, createDefaultAssetWithCollection, createDefaultCollection, decodeAssetV1, decodeCollectionV1, decodeHashedAssetV1, decodePluginHeaderV1, decodePluginRegistryV1, externalPluginAdapter, externalPluginAdapterInitInfo, externalPluginAdapterKey, externalPluginAdapterUpdateInfo, extraAccount, fetchAllAssetV1, fetchAllCollectionV1, fetchAllHashedAssetV1, fetchAllMaybeAssetV1, fetchAllMaybeCollectionV1, fetchAllMaybeHashedAssetV1, fetchAllMaybePluginHeaderV1, fetchAllMaybePluginRegistryV1, fetchAllPluginHeaderV1, fetchAllPluginRegistryV1, fetchAssetPlugin, fetchAssetV1, fetchCollectionPlugin, fetchCollectionV1, fetchHashedAssetV1, fetchMaybeAssetV1, fetchMaybeCollectionV1, fetchMaybeHashedAssetV1, fetchMaybePluginHeaderV1, fetchMaybePluginRegistryV1, fetchPluginHeaderV1, fetchPluginRegistryV1, getAddBlockerCodec, getAddBlockerDecoder, getAddBlockerEncoder, getAddCollectionExternalPluginAdapterV1DiscriminatorBytes, getAddCollectionExternalPluginAdapterV1Instruction, getAddCollectionExternalPluginAdapterV1InstructionDataCodec, getAddCollectionExternalPluginAdapterV1InstructionDataDecoder, getAddCollectionExternalPluginAdapterV1InstructionDataEncoder, getAddCollectionPluginV1DiscriminatorBytes, getAddCollectionPluginV1Instruction, getAddCollectionPluginV1InstructionDataCodec, getAddCollectionPluginV1InstructionDataDecoder, getAddCollectionPluginV1InstructionDataEncoder, getAddExternalPluginAdapterV1DiscriminatorBytes, getAddExternalPluginAdapterV1Instruction, getAddExternalPluginAdapterV1InstructionDataCodec, getAddExternalPluginAdapterV1InstructionDataDecoder, getAddExternalPluginAdapterV1InstructionDataEncoder, getAddPluginV1DiscriminatorBytes, getAddPluginV1Instruction, getAddPluginV1InstructionDataCodec, getAddPluginV1InstructionDataDecoder, getAddPluginV1InstructionDataEncoder, getApproveCollectionPluginAuthorityV1DiscriminatorBytes, getApproveCollectionPluginAuthorityV1Instruction, getApproveCollectionPluginAuthorityV1InstructionDataCodec, getApproveCollectionPluginAuthorityV1InstructionDataDecoder, getApproveCollectionPluginAuthorityV1InstructionDataEncoder, getApprovePluginAuthorityV1DiscriminatorBytes, getApprovePluginAuthorityV1Instruction, getApprovePluginAuthorityV1InstructionDataCodec, getApprovePluginAuthorityV1InstructionDataDecoder, getApprovePluginAuthorityV1InstructionDataEncoder, getAssetV1Codec, getAssetV1Decoder, getAssetV1Encoder, getAttributeCodec, getAttributeDecoder, getAttributeEncoder, getAttributesCodec, getAttributesDecoder, getAttributesEncoder, getAuthorityCodec, getAuthorityDecoder, getAuthorityEncoder, getAutographCodec, getAutographDecoder, getAutographEncoder, getAutographSignatureCodec, getAutographSignatureDecoder, getAutographSignatureEncoder, getBurnCollectionV1DiscriminatorBytes, getBurnCollectionV1Instruction, getBurnCollectionV1InstructionDataCodec, getBurnCollectionV1InstructionDataDecoder, getBurnCollectionV1InstructionDataEncoder, getBurnDelegateCodec, getBurnDelegateDecoder, getBurnDelegateEncoder, getBurnV1DiscriminatorBytes, getBurnV1Instruction, getBurnV1InstructionDataCodec, getBurnV1InstructionDataDecoder, getBurnV1InstructionDataEncoder, getCollectDiscriminatorBytes, getCollectInstruction, getCollectInstructionDataCodec, getCollectInstructionDataDecoder, getCollectInstructionDataEncoder, getCollectionV1Codec, getCollectionV1Decoder, getCollectionV1Encoder, getCompressV1DiscriminatorBytes, getCompressV1Instruction, getCompressV1InstructionDataCodec, getCompressV1InstructionDataDecoder, getCompressV1InstructionDataEncoder, getCompressionProofCodec, getCompressionProofDecoder, getCompressionProofEncoder, getCreateCollectionV1DiscriminatorBytes, getCreateCollectionV1Instruction, getCreateCollectionV1InstructionDataCodec, getCreateCollectionV1InstructionDataDecoder, getCreateCollectionV1InstructionDataEncoder, getCreateCollectionV2DiscriminatorBytes, getCreateCollectionV2Instruction, getCreateCollectionV2InstructionDataCodec, getCreateCollectionV2InstructionDataDecoder, getCreateCollectionV2InstructionDataEncoder, getCreateV1DiscriminatorBytes, getCreateV1Instruction, getCreateV1InstructionDataCodec, getCreateV1InstructionDataDecoder, getCreateV1InstructionDataEncoder, getCreateV2DiscriminatorBytes, getCreateV2Instruction, getCreateV2InstructionDataCodec, getCreateV2InstructionDataDecoder, getCreateV2InstructionDataEncoder, getCreatorCodec, getCreatorDecoder, getCreatorEncoder, getDataStateCodec, getDataStateDecoder, getDataStateEncoder, getDataStoreCodec, getDataStoreDecoder, getDataStoreEncoder, getDataStoreInitInfoCodec, getDataStoreInitInfoDecoder, getDataStoreInitInfoEncoder, getDataStoreUpdateInfoCodec, getDataStoreUpdateInfoDecoder, getDataStoreUpdateInfoEncoder, getDecompressV1DiscriminatorBytes, getDecompressV1Instruction, getDecompressV1InstructionDataCodec, getDecompressV1InstructionDataDecoder, getDecompressV1InstructionDataEncoder, getEditionCodec, getEditionDecoder, getEditionEncoder, getExternalCheckResultCodec, getExternalCheckResultDecoder, getExternalCheckResultEncoder, getExternalPluginAdapterCodec, getExternalPluginAdapterDecoder, getExternalPluginAdapterEncoder, getExternalPluginAdapterInitInfoCodec, getExternalPluginAdapterInitInfoDecoder, getExternalPluginAdapterInitInfoEncoder, getExternalPluginAdapterKeyCodec, getExternalPluginAdapterKeyDecoder, getExternalPluginAdapterKeyEncoder, getExternalPluginAdapterSchemaCodec, getExternalPluginAdapterSchemaDecoder, getExternalPluginAdapterSchemaEncoder, getExternalPluginAdapterTypeCodec, getExternalPluginAdapterTypeDecoder, getExternalPluginAdapterTypeEncoder, getExternalPluginAdapterUpdateInfoCodec, getExternalPluginAdapterUpdateInfoDecoder, getExternalPluginAdapterUpdateInfoEncoder, getExternalRegistryRecordCodec, getExternalRegistryRecordDecoder, getExternalRegistryRecordEncoder, getExternalValidationResultCodec, getExternalValidationResultDecoder, getExternalValidationResultEncoder, getExtraAccountCodec, getExtraAccountDecoder, getExtraAccountEncoder, getFreezeDelegateCodec, getFreezeDelegateDecoder, getFreezeDelegateEncoder, getHashablePluginSchemaCodec, getHashablePluginSchemaDecoder, getHashablePluginSchemaEncoder, getHashedAssetSchemaCodec, getHashedAssetSchemaDecoder, getHashedAssetSchemaEncoder, getHashedAssetV1Codec, getHashedAssetV1Decoder, getHashedAssetV1Encoder, getHashedAssetV1Size, getHookableLifecycleEventCodec, getHookableLifecycleEventDecoder, getHookableLifecycleEventEncoder, getImmutableMetadataCodec, getImmutableMetadataDecoder, getImmutableMetadataEncoder, getKeyCodec, getKeyDecoder, getKeyEncoder, getLifecycleHookCodec, getLifecycleHookDecoder, getLifecycleHookEncoder, getLifecycleHookInitInfoCodec, getLifecycleHookInitInfoDecoder, getLifecycleHookInitInfoEncoder, getLifecycleHookUpdateInfoCodec, getLifecycleHookUpdateInfoDecoder, getLifecycleHookUpdateInfoEncoder, getMasterEditionCodec, getMasterEditionDecoder, getMasterEditionEncoder, getMplCoreProgramErrorMessage, getOracleCodec, getOracleDecoder, getOracleEncoder, getOracleInitInfoCodec, getOracleInitInfoDecoder, getOracleInitInfoEncoder, getOracleUpdateInfoCodec, getOracleUpdateInfoDecoder, getOracleUpdateInfoEncoder, getOracleValidationCodec, getOracleValidationDecoder, getOracleValidationEncoder, getPermanentBurnDelegateCodec, getPermanentBurnDelegateDecoder, getPermanentBurnDelegateEncoder, getPermanentFreezeDelegateCodec, getPermanentFreezeDelegateDecoder, getPermanentFreezeDelegateEncoder, getPermanentTransferDelegateCodec, getPermanentTransferDelegateDecoder, getPermanentTransferDelegateEncoder, getPluginAuthorityPairCodec, getPluginAuthorityPairDecoder, getPluginAuthorityPairEncoder, getPluginCodec, getPluginDecoder, getPluginEncoder, getPluginHeaderV1Codec, getPluginHeaderV1Decoder, getPluginHeaderV1Encoder, getPluginHeaderV1Size, getPluginRegistryV1Codec, getPluginRegistryV1Decoder, getPluginRegistryV1Encoder, getPluginTypeCodec, getPluginTypeDecoder, getPluginTypeEncoder, getRegistryRecordCodec, getRegistryRecordDecoder, getRegistryRecordEncoder, getRemoveCollectionExternalPluginAdapterV1DiscriminatorBytes, getRemoveCollectionExternalPluginAdapterV1Instruction, getRemoveCollectionExternalPluginAdapterV1InstructionDataCodec, getRemoveCollectionExternalPluginAdapterV1InstructionDataDecoder, getRemoveCollectionExternalPluginAdapterV1InstructionDataEncoder, getRemoveCollectionPluginV1DiscriminatorBytes, getRemoveCollectionPluginV1Instruction, getRemoveCollectionPluginV1InstructionDataCodec, getRemoveCollectionPluginV1InstructionDataDecoder, getRemoveCollectionPluginV1InstructionDataEncoder, getRemoveExternalPluginAdapterV1DiscriminatorBytes, getRemoveExternalPluginAdapterV1Instruction, getRemoveExternalPluginAdapterV1InstructionDataCodec, getRemoveExternalPluginAdapterV1InstructionDataDecoder, getRemoveExternalPluginAdapterV1InstructionDataEncoder, getRemovePluginV1DiscriminatorBytes, getRemovePluginV1Instruction, getRemovePluginV1InstructionDataCodec, getRemovePluginV1InstructionDataDecoder, getRemovePluginV1InstructionDataEncoder, getRevokeCollectionPluginAuthorityV1DiscriminatorBytes, getRevokeCollectionPluginAuthorityV1Instruction, getRevokeCollectionPluginAuthorityV1InstructionDataCodec, getRevokeCollectionPluginAuthorityV1InstructionDataDecoder, getRevokeCollectionPluginAuthorityV1InstructionDataEncoder, getRevokePluginAuthorityV1DiscriminatorBytes, getRevokePluginAuthorityV1Instruction, getRevokePluginAuthorityV1InstructionDataCodec, getRevokePluginAuthorityV1InstructionDataDecoder, getRevokePluginAuthorityV1InstructionDataEncoder, getRoyaltiesCodec, getRoyaltiesDecoder, getRoyaltiesEncoder, getRuleSetCodec, getRuleSetDecoder, getRuleSetEncoder, getSeedCodec, getSeedDecoder, getSeedEncoder, getTransferDelegateCodec, getTransferDelegateDecoder, getTransferDelegateEncoder, getTransferV1DiscriminatorBytes, getTransferV1Instruction, getTransferV1InstructionDataCodec, getTransferV1InstructionDataDecoder, getTransferV1InstructionDataEncoder, getUpdateAuthorityCodec, getUpdateAuthorityDecoder, getUpdateAuthorityEncoder, getUpdateCollectionExternalPluginAdapterV1DiscriminatorBytes, getUpdateCollectionExternalPluginAdapterV1Instruction, getUpdateCollectionExternalPluginAdapterV1InstructionDataCodec, getUpdateCollectionExternalPluginAdapterV1InstructionDataDecoder, getUpdateCollectionExternalPluginAdapterV1InstructionDataEncoder, getUpdateCollectionPluginV1DiscriminatorBytes, getUpdateCollectionPluginV1Instruction, getUpdateCollectionPluginV1InstructionDataCodec, getUpdateCollectionPluginV1InstructionDataDecoder, getUpdateCollectionPluginV1InstructionDataEncoder, getUpdateCollectionV1DiscriminatorBytes, getUpdateCollectionV1Instruction, getUpdateCollectionV1InstructionDataCodec, getUpdateCollectionV1InstructionDataDecoder, getUpdateCollectionV1InstructionDataEncoder, getUpdateDelegateCodec, getUpdateDelegateDecoder, getUpdateDelegateEncoder, getUpdateExternalPluginAdapterV1DiscriminatorBytes, getUpdateExternalPluginAdapterV1Instruction, getUpdateExternalPluginAdapterV1InstructionDataCodec, getUpdateExternalPluginAdapterV1InstructionDataDecoder, getUpdateExternalPluginAdapterV1InstructionDataEncoder, getUpdatePluginV1DiscriminatorBytes, getUpdatePluginV1Instruction, getUpdatePluginV1InstructionDataCodec, getUpdatePluginV1InstructionDataDecoder, getUpdatePluginV1InstructionDataEncoder, getUpdateV1DiscriminatorBytes, getUpdateV1Instruction, getUpdateV1InstructionDataCodec, getUpdateV1InstructionDataDecoder, getUpdateV1InstructionDataEncoder, getValidationResultCodec, getValidationResultDecoder, getValidationResultEncoder, getValidationResultsOffsetCodec, getValidationResultsOffsetDecoder, getValidationResultsOffsetEncoder, getVerifiedCreatorsCodec, getVerifiedCreatorsDecoder, getVerifiedCreatorsEncoder, getVerifiedCreatorsSignatureCodec, getVerifiedCreatorsSignatureDecoder, getVerifiedCreatorsSignatureEncoder, getWriteCollectionExternalPluginAdapterDataV1DiscriminatorBytes, getWriteCollectionExternalPluginAdapterDataV1Instruction, getWriteCollectionExternalPluginAdapterDataV1InstructionDataCodec, getWriteCollectionExternalPluginAdapterDataV1InstructionDataDecoder, getWriteCollectionExternalPluginAdapterDataV1InstructionDataEncoder, getWriteExternalPluginAdapterDataV1DiscriminatorBytes, getWriteExternalPluginAdapterDataV1Instruction, getWriteExternalPluginAdapterDataV1InstructionDataCodec, getWriteExternalPluginAdapterDataV1InstructionDataDecoder, getWriteExternalPluginAdapterDataV1InstructionDataEncoder, identifyMplCoreProgramInstruction, isAuthority, isExternalPluginAdapter, isExternalPluginAdapterInitInfo, isExternalPluginAdapterKey, isExternalPluginAdapterUpdateInfo, isExtraAccount, isMplCoreProgramError, isOracleValidation, isPlugin, isRuleSet, isSeed, isUpdateAuthority, isValidationResultsOffset, oracleValidation, parseAddCollectionExternalPluginAdapterV1Instruction, parseAddCollectionPluginV1Instruction, parseAddExternalPluginAdapterV1Instruction, parseAddPluginV1Instruction, parseApproveCollectionPluginAuthorityV1Instruction, parseApprovePluginAuthorityV1Instruction, parseBurnCollectionV1Instruction, parseBurnV1Instruction, parseCollectInstruction, parseCompressV1Instruction, parseCreateCollectionV1Instruction, parseCreateCollectionV2Instruction, parseCreateV1Instruction, parseCreateV2Instruction, parseDecompressV1Instruction, parseRemoveCollectionExternalPluginAdapterV1Instruction, parseRemoveCollectionPluginV1Instruction, parseRemoveExternalPluginAdapterV1Instruction, parseRemovePluginV1Instruction, parseRevokeCollectionPluginAuthorityV1Instruction, parseRevokePluginAuthorityV1Instruction, parseTransferV1Instruction, parseUpdateCollectionExternalPluginAdapterV1Instruction, parseUpdateCollectionPluginV1Instruction, parseUpdateCollectionV1Instruction, parseUpdateExternalPluginAdapterV1Instruction, parseUpdatePluginV1Instruction, parseUpdateV1Instruction, parseWriteCollectionExternalPluginAdapterDataV1Instruction, parseWriteExternalPluginAdapterDataV1Instruction, plugin, ruleSet, seed, updateAuthority, validationResultsOffset };
//# sourceMappingURL=index.mjs.map
//# sourceMappingURL=index.mjs.map