/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { type ExternalPluginAdapterInitInfo, type ExternalPluginAdapterInitInfoArgs } from '../types';
export declare const ADD_EXTERNAL_PLUGIN_ADAPTER_V1_DISCRIMINATOR = 22;
export declare function getAddExternalPluginAdapterV1DiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type AddExternalPluginAdapterV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountAsset extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAsset extends string ? WritableAccount<TAccountAsset> : TAccountAsset,
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type AddExternalPluginAdapterV1InstructionData = {
    discriminator: number;
    initInfo: ExternalPluginAdapterInitInfo;
};
export type AddExternalPluginAdapterV1InstructionDataArgs = {
    initInfo: ExternalPluginAdapterInitInfoArgs;
};
export declare function getAddExternalPluginAdapterV1InstructionDataEncoder(): Encoder<AddExternalPluginAdapterV1InstructionDataArgs>;
export declare function getAddExternalPluginAdapterV1InstructionDataDecoder(): Decoder<AddExternalPluginAdapterV1InstructionData>;
export declare function getAddExternalPluginAdapterV1InstructionDataCodec(): Codec<AddExternalPluginAdapterV1InstructionDataArgs, AddExternalPluginAdapterV1InstructionData>;
export type AddExternalPluginAdapterV1Input<TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    asset: Address<TAccountAsset>;
    /** The collection to which the asset belongs */
    collection?: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The owner or delegate of the asset */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    initInfo: AddExternalPluginAdapterV1InstructionDataArgs['initInfo'];
};
export declare function getAddExternalPluginAdapterV1Instruction<TAccountAsset extends string, TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string, TProgramAddress extends Address = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS>(input: AddExternalPluginAdapterV1Input<TAccountAsset, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>, config?: {
    programAddress?: TProgramAddress;
}): AddExternalPluginAdapterV1Instruction<TProgramAddress, TAccountAsset, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedAddExternalPluginAdapterV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        asset: TAccountMetas[0];
        /** The collection to which the asset belongs */
        collection?: TAccountMetas[1] | undefined;
        /** The account paying for the storage fees */
        payer: TAccountMetas[2];
        /** The owner or delegate of the asset */
        authority?: TAccountMetas[3] | undefined;
        /** The system program */
        systemProgram: TAccountMetas[4];
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[5] | undefined;
    };
    data: AddExternalPluginAdapterV1InstructionData;
};
export declare function parseAddExternalPluginAdapterV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedAddExternalPluginAdapterV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=addExternalPluginAdapterV1.d.ts.map