/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { type Authority, type AuthorityArgs, type Plugin, type PluginArgs } from '../types';
export declare const ADD_PLUGIN_V1_DISCRIMINATOR = 2;
export declare function getAddPluginV1DiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type AddPluginV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountAsset extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAsset extends string ? WritableAccount<TAccountAsset> : TAccountAsset,
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type AddPluginV1InstructionData = {
    discriminator: number;
    plugin: Plugin;
    initAuthority: Option<Authority>;
};
export type AddPluginV1InstructionDataArgs = {
    plugin: PluginArgs;
    initAuthority: OptionOrNullable<AuthorityArgs>;
};
export declare function getAddPluginV1InstructionDataEncoder(): Encoder<AddPluginV1InstructionDataArgs>;
export declare function getAddPluginV1InstructionDataDecoder(): Decoder<AddPluginV1InstructionData>;
export declare function getAddPluginV1InstructionDataCodec(): Codec<AddPluginV1InstructionDataArgs, AddPluginV1InstructionData>;
export type AddPluginV1Input<TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    asset: Address<TAccountAsset>;
    /** The collection to which the asset belongs */
    collection?: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The owner or delegate of the asset */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    plugin: AddPluginV1InstructionDataArgs['plugin'];
    initAuthority: AddPluginV1InstructionDataArgs['initAuthority'];
};
export declare function getAddPluginV1Instruction<TAccountAsset extends string, TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string, TProgramAddress extends Address = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS>(input: AddPluginV1Input<TAccountAsset, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>, config?: {
    programAddress?: TProgramAddress;
}): AddPluginV1Instruction<TProgramAddress, TAccountAsset, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedAddPluginV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        asset: TAccountMetas[0];
        /** The collection to which the asset belongs */
        collection?: TAccountMetas[1] | undefined;
        /** The account paying for the storage fees */
        payer: TAccountMetas[2];
        /** The owner or delegate of the asset */
        authority?: TAccountMetas[3] | undefined;
        /** The system program */
        systemProgram: TAccountMetas[4];
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[5] | undefined;
    };
    data: AddPluginV1InstructionData;
};
export declare function parseAddPluginV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedAddPluginV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=addPluginV1.d.ts.map