/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { type Authority, type AuthorityArgs, type PluginType, type PluginTypeArgs } from '../types';
export declare const APPROVE_COLLECTION_PLUGIN_AUTHORITY_V1_DISCRIMINATOR = 9;
export declare function getApproveCollectionPluginAuthorityV1DiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type ApproveCollectionPluginAuthorityV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type ApproveCollectionPluginAuthorityV1InstructionData = {
    discriminator: number;
    pluginType: PluginType;
    newAuthority: Authority;
};
export type ApproveCollectionPluginAuthorityV1InstructionDataArgs = {
    pluginType: PluginTypeArgs;
    newAuthority: AuthorityArgs;
};
export declare function getApproveCollectionPluginAuthorityV1InstructionDataEncoder(): Encoder<ApproveCollectionPluginAuthorityV1InstructionDataArgs>;
export declare function getApproveCollectionPluginAuthorityV1InstructionDataDecoder(): Decoder<ApproveCollectionPluginAuthorityV1InstructionData>;
export declare function getApproveCollectionPluginAuthorityV1InstructionDataCodec(): Codec<ApproveCollectionPluginAuthorityV1InstructionDataArgs, ApproveCollectionPluginAuthorityV1InstructionData>;
export type ApproveCollectionPluginAuthorityV1Input<TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    collection: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The owner or delegate of the asset */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    pluginType: ApproveCollectionPluginAuthorityV1InstructionDataArgs['pluginType'];
    newAuthority: ApproveCollectionPluginAuthorityV1InstructionDataArgs['newAuthority'];
};
export declare function getApproveCollectionPluginAuthorityV1Instruction<TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string, TProgramAddress extends Address = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS>(input: ApproveCollectionPluginAuthorityV1Input<TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>, config?: {
    programAddress?: TProgramAddress;
}): ApproveCollectionPluginAuthorityV1Instruction<TProgramAddress, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedApproveCollectionPluginAuthorityV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        collection: TAccountMetas[0];
        /** The account paying for the storage fees */
        payer: TAccountMetas[1];
        /** The owner or delegate of the asset */
        authority?: TAccountMetas[2] | undefined;
        /** The system program */
        systemProgram: TAccountMetas[3];
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[4] | undefined;
    };
    data: ApproveCollectionPluginAuthorityV1InstructionData;
};
export declare function parseApproveCollectionPluginAuthorityV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedApproveCollectionPluginAuthorityV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=approveCollectionPluginAuthorityV1.d.ts.map