/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { type CompressionProof, type CompressionProofArgs } from '../types';
export declare const BURN_COLLECTION_V1_DISCRIMINATOR = 13;
export declare function getBurnCollectionV1DiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type BurnCollectionV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? WritableSignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type BurnCollectionV1InstructionData = {
    discriminator: number;
    compressionProof: Option<CompressionProof>;
};
export type BurnCollectionV1InstructionDataArgs = {
    compressionProof: OptionOrNullable<CompressionProofArgs>;
};
export declare function getBurnCollectionV1InstructionDataEncoder(): Encoder<BurnCollectionV1InstructionDataArgs>;
export declare function getBurnCollectionV1InstructionDataDecoder(): Decoder<BurnCollectionV1InstructionData>;
export declare function getBurnCollectionV1InstructionDataCodec(): Codec<BurnCollectionV1InstructionDataArgs, BurnCollectionV1InstructionData>;
export type BurnCollectionV1Input<TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    collection: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The owner or delegate of the asset */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProof: BurnCollectionV1InstructionDataArgs['compressionProof'];
};
export declare function getBurnCollectionV1Instruction<TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountLogWrapper extends string, TProgramAddress extends Address = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS>(input: BurnCollectionV1Input<TAccountCollection, TAccountPayer, TAccountAuthority, TAccountLogWrapper>, config?: {
    programAddress?: TProgramAddress;
}): BurnCollectionV1Instruction<TProgramAddress, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountLogWrapper>;
export type ParsedBurnCollectionV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        collection: TAccountMetas[0];
        /** The account paying for the storage fees */
        payer: TAccountMetas[1];
        /** The owner or delegate of the asset */
        authority?: TAccountMetas[2] | undefined;
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[3] | undefined;
    };
    data: BurnCollectionV1InstructionData;
};
export declare function parseBurnCollectionV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedBurnCollectionV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=burnCollectionV1.d.ts.map