/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type TransactionSigner, type WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { type PluginAuthorityPair, type PluginAuthorityPairArgs } from '../types';
export declare const CREATE_COLLECTION_V1_DISCRIMINATOR = 1;
export declare function getCreateCollectionV1DiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type CreateCollectionV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountCollection extends string ? WritableSignerAccount<TAccountCollection> & IAccountSignerMeta<TAccountCollection> : TAccountCollection,
    TAccountUpdateAuthority extends string ? ReadonlyAccount<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CreateCollectionV1InstructionData = {
    discriminator: number;
    name: string;
    uri: string;
    plugins: Option<Array<PluginAuthorityPair>>;
};
export type CreateCollectionV1InstructionDataArgs = {
    name: string;
    uri: string;
    plugins: OptionOrNullable<Array<PluginAuthorityPairArgs>>;
};
export declare function getCreateCollectionV1InstructionDataEncoder(): Encoder<CreateCollectionV1InstructionDataArgs>;
export declare function getCreateCollectionV1InstructionDataDecoder(): Decoder<CreateCollectionV1InstructionData>;
export declare function getCreateCollectionV1InstructionDataCodec(): Codec<CreateCollectionV1InstructionDataArgs, CreateCollectionV1InstructionData>;
export type CreateCollectionV1Input<TAccountCollection extends string = string, TAccountUpdateAuthority extends string = string, TAccountPayer extends string = string, TAccountSystemProgram extends string = string> = {
    /** The address of the new asset */
    collection: TransactionSigner<TAccountCollection>;
    /** The authority of the new asset */
    updateAuthority?: Address<TAccountUpdateAuthority>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    name: CreateCollectionV1InstructionDataArgs['name'];
    uri: CreateCollectionV1InstructionDataArgs['uri'];
    plugins: CreateCollectionV1InstructionDataArgs['plugins'];
};
export declare function getCreateCollectionV1Instruction<TAccountCollection extends string, TAccountUpdateAuthority extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS>(input: CreateCollectionV1Input<TAccountCollection, TAccountUpdateAuthority, TAccountPayer, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): CreateCollectionV1Instruction<TProgramAddress, TAccountCollection, TAccountUpdateAuthority, TAccountPayer, TAccountSystemProgram>;
export type ParsedCreateCollectionV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the new asset */
        collection: TAccountMetas[0];
        /** The authority of the new asset */
        updateAuthority?: TAccountMetas[1] | undefined;
        /** The account paying for the storage fees */
        payer: TAccountMetas[2];
        /** The system program */
        systemProgram: TAccountMetas[3];
    };
    data: CreateCollectionV1InstructionData;
};
export declare function parseCreateCollectionV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateCollectionV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createCollectionV1.d.ts.map