/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type TransactionSigner, type WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { type ExternalPluginAdapterInitInfo, type ExternalPluginAdapterInitInfoArgs, type PluginAuthorityPair, type PluginAuthorityPairArgs } from '../types';
export declare const CREATE_COLLECTION_V2_DISCRIMINATOR = 21;
export declare function getCreateCollectionV2DiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type CreateCollectionV2Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountCollection extends string ? WritableSignerAccount<TAccountCollection> & IAccountSignerMeta<TAccountCollection> : TAccountCollection,
    TAccountUpdateAuthority extends string ? ReadonlyAccount<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CreateCollectionV2InstructionData = {
    discriminator: number;
    name: string;
    uri: string;
    plugins: Option<Array<PluginAuthorityPair>>;
    externalPluginAdapters: Option<Array<ExternalPluginAdapterInitInfo>>;
};
export type CreateCollectionV2InstructionDataArgs = {
    name: string;
    uri: string;
    plugins: OptionOrNullable<Array<PluginAuthorityPairArgs>>;
    externalPluginAdapters: OptionOrNullable<Array<ExternalPluginAdapterInitInfoArgs>>;
};
export declare function getCreateCollectionV2InstructionDataEncoder(): Encoder<CreateCollectionV2InstructionDataArgs>;
export declare function getCreateCollectionV2InstructionDataDecoder(): Decoder<CreateCollectionV2InstructionData>;
export declare function getCreateCollectionV2InstructionDataCodec(): Codec<CreateCollectionV2InstructionDataArgs, CreateCollectionV2InstructionData>;
export type CreateCollectionV2Input<TAccountCollection extends string = string, TAccountUpdateAuthority extends string = string, TAccountPayer extends string = string, TAccountSystemProgram extends string = string> = {
    /** The address of the new asset */
    collection: TransactionSigner<TAccountCollection>;
    /** The authority of the new asset */
    updateAuthority?: Address<TAccountUpdateAuthority>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    name: CreateCollectionV2InstructionDataArgs['name'];
    uri: CreateCollectionV2InstructionDataArgs['uri'];
    plugins: CreateCollectionV2InstructionDataArgs['plugins'];
    externalPluginAdapters: CreateCollectionV2InstructionDataArgs['externalPluginAdapters'];
};
export declare function getCreateCollectionV2Instruction<TAccountCollection extends string, TAccountUpdateAuthority extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS>(input: CreateCollectionV2Input<TAccountCollection, TAccountUpdateAuthority, TAccountPayer, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): CreateCollectionV2Instruction<TProgramAddress, TAccountCollection, TAccountUpdateAuthority, TAccountPayer, TAccountSystemProgram>;
export type ParsedCreateCollectionV2Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the new asset */
        collection: TAccountMetas[0];
        /** The authority of the new asset */
        updateAuthority?: TAccountMetas[1] | undefined;
        /** The account paying for the storage fees */
        payer: TAccountMetas[2];
        /** The system program */
        systemProgram: TAccountMetas[3];
    };
    data: CreateCollectionV2InstructionData;
};
export declare function parseCreateCollectionV2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateCollectionV2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createCollectionV2.d.ts.map