/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { type DataState, type DataStateArgs, type ExternalPluginAdapterInitInfo, type ExternalPluginAdapterInitInfoArgs, type PluginAuthorityPair, type PluginAuthorityPairArgs } from '../types';
export declare const CREATE_V2_DISCRIMINATOR = 20;
export declare function getCreateV2DiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type CreateV2Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountAsset extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAsset extends string ? WritableSignerAccount<TAccountAsset> & IAccountSignerMeta<TAccountAsset> : TAccountAsset,
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountOwner extends string ? ReadonlyAccount<TAccountOwner> : TAccountOwner,
    TAccountUpdateAuthority extends string ? ReadonlyAccount<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type CreateV2InstructionData = {
    discriminator: number;
    dataState: DataState;
    name: string;
    uri: string;
    plugins: Option<Array<PluginAuthorityPair>>;
    externalPluginAdapters: Option<Array<ExternalPluginAdapterInitInfo>>;
};
export type CreateV2InstructionDataArgs = {
    dataState: DataStateArgs;
    name: string;
    uri: string;
    plugins: OptionOrNullable<Array<PluginAuthorityPairArgs>>;
    externalPluginAdapters: OptionOrNullable<Array<ExternalPluginAdapterInitInfoArgs>>;
};
export declare function getCreateV2InstructionDataEncoder(): Encoder<CreateV2InstructionDataArgs>;
export declare function getCreateV2InstructionDataDecoder(): Decoder<CreateV2InstructionData>;
export declare function getCreateV2InstructionDataCodec(): Codec<CreateV2InstructionDataArgs, CreateV2InstructionData>;
export type CreateV2Input<TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountAuthority extends string = string, TAccountPayer extends string = string, TAccountOwner extends string = string, TAccountUpdateAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the new asset */
    asset: TransactionSigner<TAccountAsset>;
    /** The collection to which the asset belongs */
    collection?: Address<TAccountCollection>;
    /** The authority signing for creation */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The owner of the new asset. Defaults to the authority if not present. */
    owner?: Address<TAccountOwner>;
    /** The authority on the new asset */
    updateAuthority?: Address<TAccountUpdateAuthority>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    dataState: CreateV2InstructionDataArgs['dataState'];
    name: CreateV2InstructionDataArgs['name'];
    uri: CreateV2InstructionDataArgs['uri'];
    plugins: CreateV2InstructionDataArgs['plugins'];
    externalPluginAdapters: CreateV2InstructionDataArgs['externalPluginAdapters'];
};
export declare function getCreateV2Instruction<TAccountAsset extends string, TAccountCollection extends string, TAccountAuthority extends string, TAccountPayer extends string, TAccountOwner extends string, TAccountUpdateAuthority extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string, TProgramAddress extends Address = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS>(input: CreateV2Input<TAccountAsset, TAccountCollection, TAccountAuthority, TAccountPayer, TAccountOwner, TAccountUpdateAuthority, TAccountSystemProgram, TAccountLogWrapper>, config?: {
    programAddress?: TProgramAddress;
}): CreateV2Instruction<TProgramAddress, TAccountAsset, TAccountCollection, TAccountAuthority, TAccountPayer, TAccountOwner, TAccountUpdateAuthority, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedCreateV2Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the new asset */
        asset: TAccountMetas[0];
        /** The collection to which the asset belongs */
        collection?: TAccountMetas[1] | undefined;
        /** The authority signing for creation */
        authority?: TAccountMetas[2] | undefined;
        /** The account paying for the storage fees */
        payer: TAccountMetas[3];
        /** The owner of the new asset. Defaults to the authority if not present. */
        owner?: TAccountMetas[4] | undefined;
        /** The authority on the new asset */
        updateAuthority?: TAccountMetas[5] | undefined;
        /** The system program */
        systemProgram: TAccountMetas[6];
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[7] | undefined;
    };
    data: CreateV2InstructionData;
};
export declare function parseCreateV2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateV2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createV2.d.ts.map