/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
export declare const UPDATE_COLLECTION_V1_DISCRIMINATOR = 16;
export declare function getUpdateCollectionV1DiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type UpdateCollectionV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountNewUpdateAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountNewUpdateAuthority extends string ? ReadonlyAccount<TAccountNewUpdateAuthority> : TAccountNewUpdateAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type UpdateCollectionV1InstructionData = {
    discriminator: number;
    newName: Option<string>;
    newUri: Option<string>;
};
export type UpdateCollectionV1InstructionDataArgs = {
    newName: OptionOrNullable<string>;
    newUri: OptionOrNullable<string>;
};
export declare function getUpdateCollectionV1InstructionDataEncoder(): Encoder<UpdateCollectionV1InstructionDataArgs>;
export declare function getUpdateCollectionV1InstructionDataDecoder(): Decoder<UpdateCollectionV1InstructionData>;
export declare function getUpdateCollectionV1InstructionDataCodec(): Codec<UpdateCollectionV1InstructionDataArgs, UpdateCollectionV1InstructionData>;
export type UpdateCollectionV1Input<TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountNewUpdateAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    collection: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The update authority or update authority delegate of the asset */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The new update authority of the asset */
    newUpdateAuthority?: Address<TAccountNewUpdateAuthority>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    newName: UpdateCollectionV1InstructionDataArgs['newName'];
    newUri: UpdateCollectionV1InstructionDataArgs['newUri'];
};
export declare function getUpdateCollectionV1Instruction<TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountNewUpdateAuthority extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string, TProgramAddress extends Address = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS>(input: UpdateCollectionV1Input<TAccountCollection, TAccountPayer, TAccountAuthority, TAccountNewUpdateAuthority, TAccountSystemProgram, TAccountLogWrapper>, config?: {
    programAddress?: TProgramAddress;
}): UpdateCollectionV1Instruction<TProgramAddress, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountNewUpdateAuthority, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedUpdateCollectionV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        collection: TAccountMetas[0];
        /** The account paying for the storage fees */
        payer: TAccountMetas[1];
        /** The update authority or update authority delegate of the asset */
        authority?: TAccountMetas[2] | undefined;
        /** The new update authority of the asset */
        newUpdateAuthority?: TAccountMetas[3] | undefined;
        /** The system program */
        systemProgram: TAccountMetas[4];
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[5] | undefined;
    };
    data: UpdateCollectionV1InstructionData;
};
export declare function parseUpdateCollectionV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUpdateCollectionV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=updateCollectionV1.d.ts.map